Attribute VB_Name = "M000002"
'-----------------------------------------------------------------------------'
'                           UNIVERSIDADE DE SO PAULO                         '
'                       ESCOLA DE ENGENHARIA DE SO CARLOS                    '
'                          DEPARTAMENTO DE TRANSPORTES                        '
'                            REA DE PS-GRADUAO                            '
'                                                                             '
'                        PROGRAMA EVALUATOR PARA WINDOWS                      '
'      INTERFACE PARA AVALIAO E ORDENAMENTO DE PROJETOS DE TRANSPORTE       '
'                     COM O USO DAS REDES NEURAIS ARTIFICIAIS                 '
'                                                                             '
'                      VERSO 1.00 - DESENVOLVIDA EM 01/01/98                 '
'                        POR: NILDER FURTADO/EIJI KAWAMOTO                    '
'-----------------------------------------------------------------------------'

'-----------------------------------------------------------------------------'
'                   MDULO 2 -  SERVIO DE APRENDIZAGEM/SIMULAO             '
'                                                                             '
' Este Mdulo Controla todas as atividades e rotinas do servio de aprendiza- '
' gem e Simulao: Executar o programa "N. Planner"(1); Gerar parties (2),  '
' Definir/consultar limites de normalizao(3); Gerar arquivos no formato     '
' "TTI" para leitura pelo simulador de Redes Neurais Artificiais (RNA)(4) e   '
' Verificar o desempenho de uma topologia investigada(5).                     '
'-----------------------------------------------------------------------------'
'-----------------------------------------------------------------------------'
'         01. DEFINIO DAS VARIVEIS GLOBAIS UTILIZADAS NESTE MDULO         '
'-----------------------------------------------------------------------------'
'-----------------------------------------------------------------------------'
' Registro_Particionado = Define a formatao dos dados do arquivo de parti-  '
'                         es gerado "PAR".                                  '
'-----------------------------------------------------------------------------'
Public Cod_Projeto_Anterior As Integer
Public Prioridades_Resultado(12, 12, 1)
Public Ordenamento(12)
Public St_Primeira As Boolean
Public Nmero_Projetos
Public Contador_Alternativas As Integer
Public Tipo_Normalizao As Integer
Public Type Registro_Particionado
    Cdigo_Projeto As String * 8
    Tipo_Partio As String * 3
    Status_da_Avaliao As String * 3
    Nmero_Aleatrio_Gerado As String * 10
End Type
Public Arquivo_Aux As String * 8
Public Type Registro_Avaliao_1
''    Campo_1 As String * 8
 ''   Campo_2 As String * 11
 ''Campo_3A As String * 2
 ''Campo_3B As String * 3
 ''Campo_3C As String * 1
 ''Campo_3D As String * 4
 ''Campo_4A As String * 3
 ''Campo_4B As String * 1
 ''Campo_4C As String * 2
 ''Campo_4D As String * 12 '16 '14 '" 3 '5 '8 ' 12
 ''Campo_5 As String * 17 '20 '6 '8 '19 '17 '14 '10
  Campo_1 As String * 3
  Campo_2 As String * 1
  Campo_3 As String * 2
  Campo_4 As String * 27
  Campo_5 As String * 21
  Campo_6 As String * 3
  Campo_7 As String * 1
  Campo_8 As String * 2
End Type
''Public Type Registro_Avaliao_2
  ''  Projeto As String * 24
   '' ndice  As String * 4''
''End Type
 Public Cod_Alternativa_Anterior As Integer
 Public Contador_Projetos As Integer
 Public Tipo_de_ndice As String * 3
 Public IDPR(999, 1)
 Public IDR As Currency
 Public IDR_Aux As Currency
 Public NMAR As Currency
 Public Prioridade_Prevista As Integer
 Public Prioridade_Obtida As Currency
 Public Soma_de_Prioridades As Currency

'-----------------------------------------------------------------------------'
' Registro = Varivel utilizada para receber a leitura de cada um dos regis-  '
'            tros lido atravs de Registro_Particionado.                      '
'-----------------------------------------------------------------------------'
Dim Registro As Registro_Particionado
Dim Registro_1 As Registro_Avaliao_1
''Dim Registro_2 As Registro_Avaliao_2
'-----------------------------------------------------------------------------'
' Seleo_Variveis = Array unidimensional onde fica registrado o cdigo de   '
'                     cada uma das variveis e o seu estado: presente/ausen-  '
'                     te.                                                     '
'-----------------------------------------------------------------------------'
Public Seleo_Variveis(240, 1)
'-----------------------------------------------------------------------------'
' St_Seleo_Todos = controle_checagem que determina se todas as variveis sero uti-  '
'                    lizadas para gerar o arquivo "TTI". Caso este controle_checagem   '
'                    seja "false", nem todas as variveis foram selecionadas. '
'-----------------------------------------------------------------------------'
Public St_Seleo_Todos As Boolean
'-----------------------------------------------------------------------------'
' Contador = Define o Nmero de Variveis a serem includas no arquivo "TTI". '
'-----------------------------------------------------------------------------'
Public Contador As Integer
'-----------------------------------------------------------------------------'
' Contador_Aux = Acumula o valor do Contador para que o mesmo sirva de refe-  '
'                rncia para as parties de treinamento, validao ou teste. '
'-----------------------------------------------------------------------------'
Public Contador_Aux As Integer
'-----------------------------------------------------------------------------'
' Registros_Treinamento = Acumula a quantidade de casos que esto sendo con-  '
'                         siderados na partio de treinamento para controlar '
'                         os limites do padro de PRETCHELD.                  '
'-----------------------------------------------------------------------------'
Public Registros_Treinamento As Integer
'-----------------------------------------------------------------------------'
' Registros_Teste = Acumula a quantidade de casos que esto sendo considerados'
'                   na partio de teste para controlar os limites do padro  '
'                   de PRETCHELD.                                             '
'-----------------------------------------------------------------------------'
Public Registros_Teste As Integer
'-----------------------------------------------------------------------------'
' Registros_Validao = Acumula a quantidade de casos que esto sendo conside-'
'                       rados na partio de treinamento para controlar os li-'
'                       mites do padro de PRETCHELD.                         '
'-----------------------------------------------------------------------------'
Public Registros_Validao As Integer
'------------------------------------------------------------------------------'
' Registros_Treinamento_Aux = Acumula a quantidade de casos que esto sendo    '
'                         siderados na partio de treinamento para controlar  '
'                         os limites do padro de PRETCHELD.                   '
'------------------------------------------------------------------------------'
Public Registros_Treinamento_Aux As Integer
'------------------------------------------------------------------------------'
' Registros_Validao_Aux = Acumula a quantidade de casos que esto sendo      '
'                         siderados na partio de validao para controlar    '
'                         os limites do padro de PRETCHELD.                   '
'------------------------------------------------------------------------------'
Public Registros_Validao_Aux As Integer
'------------------------------------------------------------------------------'
' Registros_Teste_Aux = Acumula a quantidade de casos que esto sendo          '
'                         siderados na partio de teste para controlar        '
'                         os limites do padro de PRETCHELD.                   '
'------------------------------------------------------------------------------'
Public Registros_Teste_Aux As Integer
'------------------------------------------------------------------------------'
' Tipo_Partio_Aux = Acumula o tipo de partio para que este valor possa ser '
'                         usado em todos os casos de abertura/gravao de ar-  '
'                         quivos.                                              '
'------------------------------------------------------------------------------'
Public Tipo_Partio_Aux As String * 3
'------------------------------------------------------------------------------'
' Posio = Acumula um contador de tabulao para ser usado na formatao das  '
'           sees do arquivo "TTI"                                            '
'------------------------------------------------------------------------------'
Public Posio As Integer
Public Partio As Integer
Public Varivel_Posicional As Variant
Public ICR As Currency
Public St_Alterao(1 To 23)

Sub Calcula_Ordenamento()
 Dim Registro_Aux As Variant
 Dim ndice_Aux As Integer
 Dim Alternativa_Final As Integer
 Dim Prioridade_Padro As Currency
 Cod_Alternativa_Anterior = 0
 For I% = 1 To 12
     For J% = 1 To 12
         Prioridades_Resultado(I%, J%, 1) = 0
     Next
 Next
 Open String_Pesquisa_1 For Random As #1 Len = 62
 Get #1, , Registro_1
 Tipo_de_ndice = Registro_1.Campo_1
 Cod_Projeto_Aux = Registro_1.Campo_6
 Cod_Alternativa_Aux = Registro_1.Campo_8
 Cod_Projeto_Anterior = Cod_Projeto_Aux
 Do While Registro_1.Campo_6 < "999"
    Contador_Alternativas = Contador_Alternativas + 1
    SearchString = Registro_1.Campo_4
    SearchChar = "e-"
    If InStr(1, SearchString, SearchChar, 1) Then
       Prioridade_Obtida = 0
    Else
       SearchString = Registro_1.Campo_4
       SearchChar = "0 "
       If InStr(1, SearchString, SearchChar, 1) Then
          Prioridade_Obtida = 0
       Else
          If Tipo_de_ndice = "IOA" Then
             SearchString = Registro_1.Campo_4
             SearchChar = "1 "
             If InStr(1, SearchString, SearchChar, 1) Then
                Prioridade_Obtida = Registro_1.Campo_3
                Prioridades_Resultado(Cod_Alternativa_Aux, Registro_1.Campo_3, 1) = Prioridade_Obtida
             End If
          Else
             Prioridade_Obtida = Registro_1.Campo_4
             Determina_Prioridade
             Prioridades_Resultado(Cod_Alternativa_Aux, Registro_1.Campo_8, 1) = Prioridade_Obtida
          End If
       End If
    End If
    Get #1, , Registro_1
    Cod_Projeto_Aux = Registro_1.Campo_6
    Cod_Alternativa_Aux = Registro_1.Campo_8
 Loop
 If Tipo_de_ndice = "IOA" Then
    Contador_Alternativas = Contador_Alternativas / 12
 End If
 Close #1
 Ordena_Resultados
End Sub


'-----------------------------------------------------------------------------'
'                                  02. ROTINAS                                '
'-----------------------------------------------------------------------------'
'-----------------------------------------------------------------------------'
'     02.1. ROTINA DE CRIAO DO ARQUIVO DE NMEROS ALEATRIOS E PARTIES    '
'                           (Menu Principal: Mnu2_2)                          '
'                        Formulrio de Chamada : F201001                      '
'-----------------------------------------------------------------------------'
Sub Cria_Arquivo_Parties()
 Dim Nmero_Auxiliar As String
 Open String_Pesquisa_1 For Output As #1
 Open String_Pesquisa_2 For Output As #2
 Nmero_Ocorrncias = 10 * Nmero_Projetos
 Set Form = F000000
 Chama_Progresso
 Abre_Tabela_F_01
 Tabela_F_01.MoveFirst
 Do Until Tabela_F_01.EOF
    Chama_Progresso_1
     If Tabela_F_01!NUM_ALEATRIO < 10 Then
        Nmero_Auxiliar = "0000000" & Tabela_F_01!NUM_ALEATRIO
     Else
        If Tabela_F_01!NUM_ALEATRIO < 100 Then
           Nmero_Auxiliar = "000000" & Tabela_F_01!NUM_ALEATRIO
        Else
           If Tabela_F_01!NUM_ALEATRIO < 1000 Then
              Nmero_Auxiliar = "00000" & Tabela_F_01!NUM_ALEATRIO
           Else
              If Tabela_F_01!NUM_ALEATRIO < 10000 Then
                 Nmero_Auxiliar = "0000" & Tabela_F_01!NUM_ALEATRIO
              Else
                 If Tabela_F_01!NUM_ALEATRIO < 100000 Then
                     Nmero_Auxiliar = "000" & Tabela_F_01!NUM_ALEATRIO
                 Else
                    If Tabela_F_01!NUM_ALEATRIO < 1000000 Then
                       Nmero_Auxiliar = "00" & Tabela_F_01!NUM_ALEATRIO
                    Else
                       If Tabela_F_01!NUM_ALEATRIO < 10000000 Then
                          Nmero_Auxiliar = "0" & Tabela_F_01!NUM_ALEATRIO
                       Else
                          Nmero_Auxiliar = Tabela_F_01!NUM_ALEATRIO
                       End If
                    End If
                 End If
              End If
           End If
        End If
     End If
    Print #2, _
     Tab(1); Nmero_Auxiliar; _
     Tab(11); Tabela_F_01!Cod_Projeto; _
     Tab(17); Tabela_F_01!ST_AVAL;
    Select Case Tipo_Padro
     Case 1
      If Tipo_Gerao_Partio = 1 Then
         If Tabela_F_01!ST_AVAL = 1 Then
            If Registros_Treinamento_Aux < Registros_Treinamento Then
               Print #1, _
                Tab(1); Tabela_F_01!Cod_Projeto; _
                Tab(8); 1; _
                Tab(11); Tabela_F_01!ST_AVAL; _
                Tab(15); Nmero_Auxiliar
                Registros_Treinamento_Aux = Registros_Treinamento_Aux + 1
            Else
               If Registros_Validao_Aux < Registros_Validao Then
                  Print #1, _
                   Tab(1); Tabela_F_01!Cod_Projeto; _
                   Tab(8); 2; _
                   Tab(11); Tabela_F_01!ST_AVAL; _
                   Tab(15); Nmero_Auxiliar
                  Registros_Validao_Aux = Registros_Validao_Aux + 1
               Else
                  Print #1, _
                   Tab(1); Tabela_F_01!Cod_Projeto; _
                   Tab(8); 3; _
                   Tab(11); Tabela_F_01!ST_AVAL; _
                   Tab(15); Nmero_Auxiliar
                  Registros_Teste_Aux = Registros_Teste_Aux + 1
               End If
            End If
         Else
            Print #1, _
             Tab(1); Tabela_F_01!Cod_Projeto; _
             Tab(8); 3; _
             Tab(11); Tabela_F_01!ST_AVAL; _
             Tab(15); Nmero_Auxiliar
            Registros_Teste_Aux = Registros_Teste_Aux + 1
         End If
      Else
      If Tabela_F_01!ST_AVAL = 1 Then
            If Registros_Treinamento_Aux < Registros_Treinamento Then
               Print #1, _
                Tab(1); Tabela_F_01!Cod_Projeto; _
                Tab(8); 1; _
                Tab(11); Tabela_F_01!ST_AVAL; _
                Tab(15); Nmero_Auxiliar
               Registros_Treinamento_Aux = Registros_Treinamento_Aux + 1
            Else
               If Registros_Validao_Aux < Registros_Validao Then
                  Print #1, _
                   Tab(1); Tabela_F_01!Cod_Projeto; _
                   Tab(8); 2; _
                   Tab(11); Tabela_F_01!ST_AVAL; _
                   Tab(15); Nmero_Auxiliar
                  Registros_Validao_Aux = Registros_Validao_Aux + 1
               Else
                 If Registros_Teste_Aux < Registros_Teste Then
                 Print #1, _
                  Tab(1); Tabela_F_01!Cod_Projeto; _
                  Tab(8); 3; _
                  Tab(11); Tabela_F_01!ST_AVAL; _
                  Tab(15); Nmero_Auxiliar
                  Registros_Teste_Aux = Registros_Teste_Aux + 1
                  End If
               End If
            End If
         Else
            Print #1, _
             Tab(1); Tabela_F_01!Cod_Projeto; _
             Tab(8); 3; _
             Tab(11); Tabela_F_01!ST_AVAL; _
             Tab(15); Nmero_Auxiliar
             Registros_Teste_Aux = Registros_Teste_Aux + 1
         End If
      End If
     Case 2
      If Tipo_Gerao_Partio = 1 Then
         If Tabela_F_01!ST_AVAL = 1 Then
            If Registros_Treinamento_Aux < Registros_Treinamento Then
               Print #1, _
                Tab(1); Tabela_F_01!Cod_Projeto; _
                Tab(8); 1; _
                Tab(11); Tabela_F_01!ST_AVAL; _
                Tab(15); Nmero_Auxiliar
                Registros_Treinamento_Aux = Registros_Treinamento_Aux + 1
            Else
               If Registros_Teste_Aux < Registros_Teste Then
                  Print #1, _
                   Tab(1); Tabela_F_01!Cod_Projeto; _
                   Tab(8); 3; _
                   Tab(11); Tabela_F_01!ST_AVAL; _
                   Tab(15); Nmero_Auxiliar
                  Registros_Teste_Aux = Registros_Teste_Aux + 1
               Else
                  Print #1, _
                   Tab(1); Tabela_F_01!Cod_Projeto; _
                   Tab(8); 2; _
                   Tab(11); Tabela_F_01!ST_AVAL; _
                   Tab(15); Nmero_Auxiliar
                  Registros_Validao_Aux = Registros_Validao_Aux + 1
               End If
            End If
         Else
            Print #1, _
             Tab(1); Tabela_F_01!Cod_Projeto; _
             Tab(8); 3; _
             Tab(11); Tabela_F_01!ST_AVAL; _
             Tab(15); Nmero_Auxiliar
            Registros_Teste_Aux = Registros_Teste_Aux + 1
         End If
      Else
      If Tabela_F_01!ST_AVAL = 1 Then
            If Registros_Treinamento_Aux < Registros_Treinamento Then
               Print #1, _
                Tab(1); Tabela_F_01!Cod_Projeto; _
                Tab(8); 1; _
                Tab(11); Tabela_F_01!ST_AVAL; _
                Tab(15); Nmero_Auxiliar
               Registros_Treinamento_Aux = Registros_Treinamento_Aux + 1
            Else
               If Registros_Teste_Aux < Registros_Teste Then
                  Print #1, _
                   Tab(1); Tabela_F_01!Cod_Projeto; _
                   Tab(8); 3; _
                   Tab(11); Tabela_F_01!ST_AVAL; _
                   Tab(15); Nmero_Auxiliar
                  Registros_Teste_Aux = Registros_Teste_Aux + 1
               Else
                 If Registros_Validao_Aux < Registros_Validao Then
                 Print #1, _
                  Tab(1); Tabela_F_01!Cod_Projeto; _
                  Tab(8); 2; _
                  Tab(11); Tabela_F_01!ST_AVAL; _
                  Tab(15); Nmero_Auxiliar
                  Registros_Validao_Aux = Registros_Validao_Aux + 1
                  End If
               End If
            End If
         Else
            Print #1, _
             Tab(1); Tabela_F_01!Cod_Projeto; _
             Tab(8); 3; _
             Tab(11); Tabela_F_01!ST_AVAL; _
             Tab(15); Nmero_Auxiliar
             Registros_Teste_Aux = Registros_Teste_Aux + 1
         End If
      End If
     Case 3
      If Tabela_F_01!ST_AVAL = 1 Then
         If Registros_Validao_Aux < Registros_Validao Then
            Print #1, _
             Tab(1); Tabela_F_01!Cod_Projeto; _
             Tab(8); 2; _
             Tab(11); Tabela_F_01!ST_AVAL; _
             Tab(15); Nmero_Auxiliar
            Registros_Validao_Aux = Registros_Validao_Aux + 1
         Else
            If Registros_Treinamento_Aux < Registros_Treinamento Then
               Print #1, _
                Tab(1); Tabela_F_01!Cod_Projeto; _
                Tab(8); 1; _
                Tab(11); Tabela_F_01!ST_AVAL; _
                Tab(15); Nmero_Auxiliar
               Registros_Treinamento_Aux = Registros_Treinamento_Aux + 1
            Else
               Print #1, _
                Tab(1); Tabela_F_01!Cod_Projeto; _
                Tab(8); 3; _
                Tab(11); Tabela_F_01!ST_AVAL; _
                Tab(15); Nmero_Auxiliar
               Registros_Teste_Aux = Registros_Teste_Aux + 1
            End If
         End If
       Else
          Print #1, _
           Tab(1); Tabela_F_01!Cod_Projeto; _
           Tab(8); 3; _
           Tab(11); Tabela_F_01!ST_AVAL; _
           Tab(15); Nmero_Auxiliar
          Registros_Teste_Aux = Registros_Teste_Aux + 1
       End If
      Case 4
      If Tabela_F_01!ST_AVAL = 1 Then
         If Registros_Validao_Aux < Registros_Validao Then
            Print #1, _
             Tab(1); Tabela_F_01!Cod_Projeto; _
             Tab(8); 2; _
             Tab(11); Tabela_F_01!ST_AVAL; _
             Tab(15); Nmero_Auxiliar
            Registros_Validao_Aux = Registros_Validao_Aux + 1
         Else
            If Registros_Teste_Aux < Registros_Teste Then
               Print #1, _
                Tab(1); Tabela_F_01!Cod_Projeto; _
                Tab(8); 3; _
                Tab(11); Tabela_F_01!ST_AVAL; _
                Tab(15); Nmero_Auxiliar
               Registros_Teste_Aux = Registros_Teste_Aux + 1
            Else
               Print #1, _
                Tab(1); Tabela_F_01!Cod_Projeto; _
                Tab(8); 1; _
                Tab(11); Tabela_F_01!ST_AVAL; _
                Tab(15); Nmero_Auxiliar
               Registros_Treinamento_Aux = Registros_Treinamento_Aux + 1
            End If
         End If
       Else
          Print #1, _
           Tab(1); Tabela_F_01!Cod_Projeto; _
           Tab(8); 3; _
           Tab(11); Tabela_F_01!ST_AVAL; _
           Tab(15); Nmero_Auxiliar
          Registros_Teste_Aux = Registros_Teste_Aux + 1
       End If
    Case 5
      If Tabela_F_01!ST_AVAL = 1 Then
         If Registros_Teste_Aux < Registros_Teste Then
            Print #1, _
             Tab(1); Tabela_F_01!Cod_Projeto; _
             Tab(8); 3; _
             Tab(11); Tabela_F_01!ST_AVAL; _
             Tab(15); Nmero_Auxiliar
             Registros_Teste_Aux = Registros_Teste_Aux + 1
         Else
            If Registros_Validao_Aux < Registros_Validao Then
               Print #1, _
                Tab(1); Tabela_F_01!Cod_Projeto; _
                Tab(8); 2; _
                Tab(11); Tabela_F_01!ST_AVAL; _
                Tab(15); Nmero_Auxiliar
                Registros_Validao_Aux = Registros_Validao_Aux + 1
            Else
               Print #1, _
                Tab(1); Tabela_F_01!Cod_Projeto; _
                Tab(8); 1; _
                Tab(11); Tabela_F_01!ST_AVAL; _
                Tab(15); Nmero_Auxiliar
                Registros_Treinamento_Aux = Registros_Treinamento_Aux + 1
            End If
         End If
       Else
          Print #1, _
           Tab(1); Tabela_F_01!Cod_Projeto; _
           Tab(8); 3; _
           Tab(11); Tabela_F_01!ST_AVAL; _
           Tab(15); Nmero_Auxiliar
           Registros_Teste_Aux = Registros_Teste_Aux + 1
       End If
       Case 6
      If Tabela_F_01!ST_AVAL = 1 Then
         If Registros_Teste_Aux < Registros_Teste Then
            Print #1, _
             Tab(1); Tabela_F_01!Cod_Projeto; _
             Tab(8); 3; _
             Tab(11); Tabela_F_01!ST_AVAL; _
             Tab(15); Nmero_Auxiliar
            Registros_Teste_Aux = Registros_Teste_Aux + 1
         Else
            If Registros_Treinamento_Aux < Registros_Treinamento Then
               Print #1, _
                Tab(1); Tabela_F_01!Cod_Projeto; _
                Tab(8); 1; _
                Tab(11); Tabela_F_01!ST_AVAL; _
                Tab(15); Nmero_Auxiliar
                Registros_Treinamento_Aux = Registros_Treinamento_Aux + 1
            Else
               Print #1, _
                Tab(1); Tabela_F_01!Cod_Projeto; _
                Tab(8); 2; _
                Tab(11); Tabela_F_01!ST_AVAL; _
                Tab(15); Nmero_Auxiliar
               Registros_Validao_Aux = Registros_Validao_Aux + 1
            End If
         End If
       Else
          Print #1, _
           Tab(1); Tabela_F_01!Cod_Projeto; _
           Tab(8); 3; _
           Tab(11); Tabela_F_01!ST_AVAL; _
           Tab(15); Nmero_Auxiliar
          Registros_Teste_Aux = Registros_Teste_Aux + 1
       End If
     End Select
     Tabela_F_01.MoveNext
 Loop
 Tabela_F_01.Close
 Print #2, Tab(1); "99999999"; Tab(12); "32767"; Tab(18); "9"
 Print #1, Tab(1); 32767; Tab(8); 9; Tab(11); 9; Tab(14); 99999999
 Close #1
 Close #2
'' Unload F201001
'' For I = 1 To 50
'' Next
Finaliza_Progresso
'' If Registros_Treinamento_Aux = 0 Or Registros_Validao_Aux = 0 _
 ''   Or Registros_Teste_Aux = 0 Then
 ''   Mensagem_2 (7)
'' Else
''    Mensagem_2 (8)
'' End If
End Sub
'-----------------------------------------------------------------------------'
'                  02.2. ROTINAS DE CRIAO DO ARQUIVO "TTI"                  '
' O arquivo "TTI" a ser utilizado pelo Neural Planner  composto das seguntes '
' sees: [LABELS], que identifica as variveis de entrada/sada; [TRAINING]  '
' onde ficam descritos os projetos/alternativas considerados na partio de   '
' treinamento; [TESTING] onde ficam descritos os projetos/alternativas consi- '
' derados na partio de validao, [INTERROGATING](2)onde ficam descritos os '
' projetos/alternativas escolhidos para o teste e a seo [LIMITS] onde ficam '
' descritos os valores mximos e mnimos considerados na normalizao de cada '
' uma das variveis selecionadas.                                             '
' (2) O Neural Planner no utiliza a definio padro de PRETCHELD que estabe-'
'     lece parties de "TREINAMENTO", "VALIDAO" e "TESTE"                  '
'-----------------------------------------------------------------------------'
'-----------------------------------------------------------------------------'
'                  02.2.a. FORMATAO DO CABEALHO  GERAL DO ARQUIVO          '
'-----------------------------------------------------------------------------'
Sub Cria_Cabealho_Tti()
 Print #1, String(1021, "-")
 Print #1, "     EVALUATOR"
 Print #1, "     ARQUIVO DE SIMULACAO DE REDES NEURAIS ARTIFICIAIS"
 Print #1, "     Desenvolvido por: Nilder Furtado/Eiji Kawamoto"
 Print #1, "     Data/Horario da Criacao/Atualizacao:"; Date; Time
 Print #1, ""
 Select Case Tipo_Servio
  Case 2, 15, 23
    Print #1, "     ESTE ARQUIVO FOI GERADO COM INDICE DE PRIORIDADE DE";
    Print #1, " ALTERNATIVA E"
    Print #1, "     DEVE SER USADO PARA SIMULACAO/APRENDIZAGEM EM REDES";
    Print #1, " COM 1 SAIDA"
  Case 3, 16, 24
    Print #1, "     ESTE ARQUIVO FOI GERADO COM INDICE DE ORDENAMENTO DE";
    Print #1, " ALTERNATIVAS E"
    Print #1, "     DEVE SER USADO PARA SIMULACAO/APRENDIZAGEM EM REDES COM";
    Print #1, " 12 SAIDAS"
 End Select
 Print #1, String(1021, "-")
 Print #1, ""
End Sub
'-----------------------------------------------------------------------------'
'             02.2.b. DEFINIO DO ARQUIVO DE PARTIES A SER ABERTO          '
'-----------------------------------------------------------------------------'
Sub Define_Arquivo_Parties()
  F000002.Caption = "Aprendizagem/Simulao - IPA - Parties"
  F000002.Mscara_1.AddItem "*.par (NPlanner)"
End Sub
Sub Determina_Prioridade()
 SearchString = Registro_1.Campo_4
 SearchChar = "."
 If InStr(1, SearchString, SearchChar, 1) Then
    Prioridade_Obtida = Registro_1.Campo_4
    If Prioridade_Obtida > 10 Then
       If Prioridade_Obtida < 100 Then
          Prioridade_Obtida = Prioridade_Obtida / 10
       Else
          If Prioridade_Obtida < 1000 Then
             Prioridade_Obtida = Prioridade_Obtida / 100
          Else
             If Prioridade_Obtida < 10000 Then
                Prioridade_Obtida = Prioridade_Obtida / 1000
             Else
                If Prioridade_Obtida < 100000 Then
                   Prioridade_Obtida = Prioridade_Obtida / 10000
                Else
                   If Prioridade_Obtida < 1000000 Then
                      Prioridade_Obtida = Prioridade_Obtida / 100000
                   Else
                      Prioridade_Obtida = Prioridade_Obtida / 1000000
                   End If
                End If
             End If
          End If
       End If
    End If
 Else
    Prioridade_Obtida = Registro_1.Campo_4
   
 End If
End Sub

'-----------------------------------------------------------------------------'
'                         02.2.c. GRAVAO DA SEO 1 - "LABELS"              '
'-----------------------------------------------------------------------------'
Sub Grava_Labels_Tti()
 Dim Contador_Variveis As Variant
 Dim Nmero As String
 Open String_Pesquisa_1 For Append As #1
 Print #1, String(1021, "-")
 Print #1, "     DESCRICAO DAS SECOES DE IDENTIFICACAO DAS VARIAVEIS";
 Print #1, " DE ENTRADA/SAIDA"
 Print #1, "     E SECOES DE TREINAMENTO, VALIDACAO, TESTE E NORMALIZACAO"
 Print #1, String(1021, "-")
 Print #1, "[LABELS]"
 If St_Seleo_Todos = True Then
    Contador_Variveis = 1
    Do Until Contador_Variveis > 240
       If Tipo_Servio = 23 Or Tipo_Servio = 24 Then
          Select Case Contador_Variveis
           Case 3
            Contador_Variveis = Contador_Variveis + 1
           Case 106
            Contador_Variveis = Contador_Variveis + 2
           End Select
       End If
       Nmero = Contador_Variveis
       If Contador_Variveis < 10 Then
          Print #1, "  [V-00"; Nmero; "]"
       Else
          If Contador_Variveis < 100 Then
             Print #1, "  [V-0"; Nmero; "]"
          Else
             Print #1, "  [V-"; Nmero; "]"
          End If
       End If
       Contador_Variveis = Contador_Variveis + 1
  Loop
 Else
    For I = 1 To 240
        Nmero = I%
        If Seleo_Variveis(I%, 1) = True Then
           If Nmero < 10 Then
              Print #1, "  [V-00"; Nmero; "]"
           Else
              If Nmero < 100 Then
                 Print #1, "  [V-0"; Nmero; "]"
              Else
                 Print #1, "  [V-"; Nmero; "]"
              End If
           End If
        End If
    Next
 End If
 Print #1, ""
 Select Case Tipo_Servio
  Case 2, 15, 17, 23
  Print #1, "  [IPA]"
 Case 3, 16, 18, 24
    Print #1, "  [IOA-01]"
    Print #1, "  [IOA-02]"
    Print #1, "  [IOA-03]"
    Print #1, "  [IOA-04]"
    Print #1, "  [IOA-05]"
    Print #1, "  [IOA-06]"
    Print #1, "  [IOA-07]"
    Print #1, "  [IOA-08]"
    Print #1, "  [IOA-09]"
    Print #1, "  [IOA-10]"
    Print #1, "  [IOA-11]"
    Print #1, "  [IOA-12]"
 End Select
 Print #1, "[END]"
 Print #1, ""
 Open String_Pesquisa_2 For Random As #3 Len = 24
 Get #3, , Registro
Cod_Projeto_Aux = Registro.Cdigo_Projeto
 Tipo_Partio_Aux = Registro.Tipo_Partio
 Do While Cod_Projeto_Aux <> 32767
    Nmero_Projetos = Nmero_Projetos + 1
    Get #3, , Registro
    Cod_Projeto_Aux = Registro.Cdigo_Projeto
 Loop
 Close #3
 Nmero_Ocorrncias = Nmero_Projetos * 3
 Set Form = F204002
 Chama_Progresso
End Sub
'-----------------------------------------------------------------------------'
'   02.2.d. GRAVAO DE CABEALHOS DAS SECOES 2, 3, 4 E 5 - TREINAMENTO,      '
'                              VALIDAO E TESTE                              '
'-----------------------------------------------------------------------------'
'-----------------------------------------------------------------------------'
'     02.2.d.1. FORMATAO DO CABEALHO DOS DADOS DE TREINAMENTO [TRAINING]   '
'-----------------------------------------------------------------------------'
Sub Grava_Header_Partio_Tti()
 Dim Header_Partio As String
 Select Case Partio
    Case 1
      Header_Partio = "[TRAINING]"
    Case 2
      Header_Partio = "[TESTING]"
    Case 3
      Header_Partio = "[INTERROGATING]"
    Case 4
      Header_Partio = "[LIMITS]"
 End Select
 Posio = 10
 If St_Seleo_Todos = True Then
    Print #1, Header_Partio;
    If Tipo_Servio = 23 Or Tipo_Servio = 24 Then
    For I = 1 To 236
        Posio = Posio + 10
        Print #1, Tab(Posio); " >";
        Verifica_ltima_Posio
    Next
    Else
    For I = 1 To 239
        Posio = Posio + 10
        Print #1, Tab(Posio); " >";
        Verifica_ltima_Posio
    Next
    End If
 Else
    Print #1, Header_Partio;
    For I = 1 To Contador_Aux - 1
        Verifica_ltima_Posio
        Posio = Posio + 10
        Print #1, Tab(Posio); " >";
    Next
 End If
 Verifica_ltima_Posio
 Posio = Posio + 10
 Print #1, Tab(Posio); " >";
 Verifica_ltima_Posio
 Select Case Tipo_Servio
  Case 2, 15, 17, 23
    Posio = Posio + 10
    Print #1, Tab(Posio); " <"
  Case 3, 16, 18, 24
    For I = 1 To 11
        Verifica_ltima_Posio
        Posio = Posio + 10
        Print #1, Tab(Posio); " <";
    Next
    Verifica_ltima_Posio
    Posio = Posio + 10
    Print #1, Tab(Posio); " <"
 End Select
End Sub



'-----------------------------------------------------------------------------'
'   02.2.e. GRAVAO DE DADOS DAS SECOES 2, 3, 4 E 5 - TREINAMENTO/VALIDAO  '
'                               TESTE E NORMALIZAO                          '
'-----------------------------------------------------------------------------'
'-----------------------------------------------------------------------------'
'               02.2.e.1. GRAVAO DOS DADOS DE TREINAMENTO [TRAINING]        '
'-----------------------------------------------------------------------------'
Sub Grava_Registros_Treinamento_Tti()
 On Error GoTo Manipulador_Erros
 Consulta_Projeto.MoveFirst
 Consulta_Alternativa.MoveFirst
 Open String_Pesquisa_2 For Random As #3 Len = 24
 Formulrio = 10
 Abre_Tabela_2
 Get #3, , Registro
 Cod_Projeto_Aux = Registro.Cdigo_Projeto
 Tipo_Partio_Aux = Registro.Tipo_Partio
 Do While Cod_Projeto_Aux <> 32767
    If Tipo_Partio_Aux = 1 Then
       Tabela_C_01_Aux.Seek "=", Cod_Projeto_Aux
          If Tabela_C_01_Aux.NoMatch Then
             Open "C:\EVALUATOR\LOGS\" & Data_1 & ".LOG" For Append As #100
             Print #100, "O PROJETO "; Cod_Projeto_Aux; " ESTA INCONSISTENTE"
             Close #100
          Else
             Busca_Registro_Consulta
             If Consulta_Alternativa.NoMatch Then
                Open "C:\EVALUATOR\LOGS\" & Data_1 & ".LOG" For Append As #100
                Print #100, "O PROJETO "; Cod_Projeto_Aux; " ESTA INCONSISTENTE"
                Close #100
             Else
                Do Until Tabela_C_01_Aux.EOF Or Consulta_Alternativa.EOF
                                 
                   If Cod_Projeto_Aux = Tabela_C_01_Aux!Cod_Projeto Then
                      Grava_Dados_Registro_Tti
                      Grava_Dados_Sada_Tti
                      Cod_Projeto_Aux = Tabela_C_01_Aux!Cod_Projeto
                   Else
                      Exit Do
                   End If
                   Tabela_C_01_Aux.MoveNext
                   Consulta_Alternativa.MoveNext
                Loop
             End If
          End If
       End If
       Tabela_C_01_Aux.MoveFirst
       Get #3, , Registro
       Cod_Projeto_Aux = Registro.Cdigo_Projeto
       Tipo_Partio_Aux = Registro.Tipo_Partio
 Loop
 Print #1, "[END]"
 Print #1, ""
 Tabela_C_01_Aux.Close
 Close #3
Manipulador_Erros:
 Select Case Err.Number
  Case 3021
   MsgBox "NO H REGISTRO EM TODAS DAS TABELAS. GERAO CANCELADA!", 48, "Atividade Inconsistente"
  End Select
End Sub
'-----------------------------------------------------------------------------'
'                02.2.e.2. GRAVAO DOS DADOS DE VALIDAO [TESTING]          '
'-----------------------------------------------------------------------------'
Sub Grava_Registros_Validao_Tti()
 On Error GoTo Manipulador_Erros
 Open String_Pesquisa_2 For Random As #3 Len = 24
 Formulrio = 10
 Abre_Tabela_2
 Get #3, , Registro
 Cod_Projeto_Aux = Registro.Cdigo_Projeto
 Tipo_Partio_Aux = Registro.Tipo_Partio
 Do While Cod_Projeto_Aux <> 32767
    If Tipo_Partio_Aux = 2 Then
       Tabela_C_01_Aux.Seek "=", Cod_Projeto_Aux
          If Tabela_C_01_Aux.NoMatch Then
             Open "C:\EVALUATOR\LOGS\" & Data_1 & ".LOG" For Append As #100
             Print #100, "O PROJETO "; Cod_Projeto_Aux; " ESTA INCONSISTENTE"
             Close #100
          Else
             Busca_Registro_Consulta
             If Consulta_Alternativa.NoMatch Then
                Open "C:\EVALUATOR\LOGS\" & Data_1 & ".LOG" For Append As #100
                Print #100, "O PROJETO "; Cod_Projeto_Aux; " ESTA INCONSISTENTE"
                Close #100
             Else
                Do Until Tabela_C_01_Aux.EOF Or Consulta_Alternativa.EOF
                   If Cod_Projeto_Aux = Tabela_C_01_Aux!Cod_Projeto Then
                      Grava_Dados_Registro_Tti
                      Grava_Dados_Sada_Tti
                      Cod_Projeto_Aux = Tabela_C_01_Aux!Cod_Projeto
                   Else
                      Exit Do
                   End If
                   Tabela_C_01_Aux.MoveNext
                   Consulta_Alternativa.MoveNext
                Loop
             End If
          End If
       End If
    Tabela_C_01_Aux.MoveFirst
    Get #3, , Registro
    Cod_Projeto_Aux = Registro.Cdigo_Projeto
    Tipo_Partio_Aux = Registro.Tipo_Partio
 Loop
 Print #1, "[END]"
 Print #1, ""
 Tabela_C_01_Aux.Close
Close #3
Manipulador_Erros:
 Select Case Err.Number
  Case 3021
   MsgBox "NO H REGISTRO EM TODAS DAS TABELAS. GERAO CANCELADA!", 48, "Atividade Inconsistente"
   Unload F204002
  End Select
End Sub
'-----------------------------------------------------------------------------'
'                 02.2.e.3. GRAVACAO DOS DADOS DE TESTE [INTERROGATING]       '
'-----------------------------------------------------------------------------'
Sub Grava_Registros_Teste_Tti()
 On Error GoTo Manipulador_Erros
 Open String_Pesquisa_2 For Random As #3 Len = 24
 Formulrio = 10
 Abre_Tabela_2
 Get #3, , Registro
 Cod_Projeto_Aux = Registro.Cdigo_Projeto
 Tipo_Partio_Aux = Registro.Tipo_Partio
 Do While Cod_Projeto_Aux <> 32767
   If Tipo_Partio_Aux = 3 Then
       Tabela_C_01_Aux.Seek "=", Cod_Projeto_Aux
        
          If Tabela_C_01_Aux.NoMatch Then
             Open "C:\EVALUATOR\LOGS\" & Data_1 & ".LOG" For Append As #100
             Print #100, "O PROJETO "; Cod_Projeto_Aux; " ESTA INCONSISTENTE"
             Close #100
          Else
             Busca_Registro_Consulta
             If Consulta_Alternativa.NoMatch Then
                Open "C:\EVALUATOR\LOGS\" & Data_1 & ".LOG" For Append As #100
                Print #100, "O PROJETO "; Cod_Projeto_Aux; " ESTA INCONSISTENTE"
                Close #100
             Else
                Do Until Tabela_C_01_Aux.EOF Or Consulta_Alternativa.EOF
                   
                   If Cod_Projeto_Aux = Tabela_C_01_Aux!Cod_Projeto Then
                      Grava_Dados_Registro_Tti
                      Grava_Dados_Sada_Tti
                      Cod_Projeto_Aux = Tabela_C_01_Aux!Cod_Projeto
                   Else
                      Exit Do
                   End If
                   Tabela_C_01_Aux.MoveNext
                   Consulta_Alternativa.MoveNext
                 Loop
              End If
          End If
    End If
    Tabela_C_01_Aux.MoveFirst
    Get #3, , Registro
    Cod_Projeto_Aux = Registro.Cdigo_Projeto
    Tipo_Partio_Aux = Registro.Tipo_Partio
 Loop
 Print #1, "[END]"
 Print #1, ""
 Tabela_C_01_Aux.Close
 Close #3
Manipulador_Erros:
 Select Case Err.Number
  Case 3021
   MsgBox "NO H REGISTRO EM TODAS DAS TABELAS. GERAO CANCELADA!", 48, "Atividade Inconsistente"
   Unload F204002
  End Select
End Sub
'-----------------------------------------------------------------------------'
'              02.2.f. CONSULTA DE CDIGOS PROJETO/ALTERNATIVAS               '
'-----------------------------------------------------------------------------'
Sub Busca_Registro_Consulta()
 Consulta_Projeto.MoveFirst
 Consulta_Alternativa.MoveFirst
 Do Until Consulta_Projeto.EOF
    If Cod_Projeto_Aux = Consulta_Projeto!Cod_Projeto Then
       Exit Do
    Else
       Consulta_Projeto.MoveNext
    End If
 Loop
 Do Until Consulta_Alternativa.EOF
    If Cod_Projeto_Aux = Consulta_Alternativa!Cod_Projeto Then
       Exit Do
    Else
    Consulta_Alternativa.MoveNext
    End If
 Loop
End Sub
'-----------------------------------------------------------------------------'
'   02.2.g. GRAVAO DOS REGISTROS DAS SECOES DE TREINAMENTO/VALIDAO/TESTE  '
'-----------------------------------------------------------------------------'
'-----------------------------------------------------------------------------'
'                02.2.g.1. FORMATAO DO CABEALHO DOS REGISTROS              '
'-----------------------------------------------------------------------------'
Sub Formata_Entrada_Registro_Tti()
 Dim Projeto As Variant
 Dim Alternativa As Variant
 Dim Projeto_Aux As String
 Dim Alternativa_Aux As String
 Projeto = Tabela_C_01_Aux!Cod_Projeto
 Alternativa = Tabela_C_01_Aux!COD_ALTERNATIVA
 Projeto_Aux = Projeto
 Alternativa_Aux = Alternativa
 If Projeto < 10 Then
    Print #1, Tab(2); "[P-00" & Projeto_Aux;
 Else
    If Projeto < 100 Then
       Print #1, Tab(2); "[P-0" & Projeto;
    Else
       Print #1, Tab(2); "[P-" & Projeto;
    End If
 End If
 If Alternativa < 10 Then
    Print #1, "-0" & Alternativa_Aux & "]";
 Else
    Print #1, "-" & Alternativa_Aux & "]";
 End If
End Sub













'-----------------------------------------------------------------------------'
'     02.2.g.2. GRAVAO DOS REGISTROS DE ENTRADA DOS PROJETOS/ALTERNATIVAS   '
'-----------------------------------------------------------------------------'
Sub Grava_Dados_Registro_Tti()
On Error Resume Next
 Chama_Progresso_1
 Posio = 10
 If St_Seleo_Todos = True Then
    Formata_Entrada_Registro_Tti
    Contador_Alternativas = Contador_Alternativas + 1
    For Nmero_Varivel = 1 To 105
        Verifica_ltima_Posio
        Select Case VarType(Consulta_Projeto(Nmero_Varivel))
         Case 0, 1
          Posio = Posio + 10
          Print #1, Tab(Posio); " ?";
         Case 2
          If Consulta_Projeto(Nmero_Varivel) = -32768 Then
             Posio = Posio + 10
             Print #1, Tab(Posio); " ?";
          Else
             Posio = Posio + 10
             Print #1, Tab(Posio); Consulta_Projeto(Nmero_Varivel);
          End If
         Case 6
          If Consulta_Projeto(Nmero_Varivel) = -32768 Then
             Posio = Posio + 10
             Print #1, Tab(Posio); " ?";
          Else
             Varivel_Posicional = Consulta_Projeto(Nmero_Varivel)
             Seleciona_Posio_Ponto
          End If
         Case 11
          Posio = Posio + 10
          If Consulta_Projeto(Nmero_Varivel) = True Then
              Print #1, Tab(Posio); 1;
          Else
              Print #1, Tab(Posio); 0;
          End If
         End Select
     Next
     For Nmero_Varivel = 2 To 136
         Verifica_ltima_Posio
         Select Case VarType(Consulta_Alternativa(Nmero_Varivel))
         Case 0, 1
          Posio = Posio + 10
          Print #1, Tab(Posio); " ?";
         Case 2
          If Consulta_Alternativa(Nmero_Varivel) = -32768 Then
             Posio = Posio + 10
             Print #1, Tab(Posio); " ?";
          Else
             Posio = Posio + 10
             Print #1, Tab(Posio); Consulta_Alternativa(Nmero_Varivel);
          End If
         Case 6
          If Consulta_Alternativa(Nmero_Varivel) = -32768 Then
             Posio = Posio + 10
             Print #1, Tab(Posio); " ?";
          Else
             Varivel_Posicional = Consulta_Alternativa(Nmero_Varivel)
             Seleciona_Posio_Ponto
          End If
         Case 11
          Posio = Posio + 10
          If Consulta_Alternativa(Nmero_Varivel) = True Then
           Print #1, Tab(Posio); 1;
          Else
           Print #1, Tab(Posio); 0;
          End If
         End Select
     Next
 Else
    Formata_Entrada_Registro_Tti
    Contador_Alternativas = Contador_Alternativas + 1
    For Nmero_Varivel = 1 To 240
        Verifica_ltima_Posio
        If Seleo_Variveis(Nmero_Varivel, 1) = True Then
           If Nmero_Varivel <= 105 Then
              Select Case VarType(Consulta_Projeto(Nmero_Varivel))
               Case 0, 1
                Posio = Posio + 10
                Print #1, Tab(Posio); " ?";
               Case 2
                If Consulta_Projeto(Nmero_Varivel) = -32768 Then
                   Posio = Posio + 10
                   Print #1, Tab(Posio); " ?";
                Else
                   Posio = Posio + 10
                   Print #1, Tab(Posio); Consulta_Projeto(Nmero_Varivel);
                End If
               Case 6
                If Consulta_Projeto(Nmero_Varivel) = -32768 Then
                   Posio = Posio + 10
                   Print #1, Tab(Posio); " ?";
                Else
                   Varivel_Posicional = Consulta_Projeto(Nmero_Varivel)
                   Seleciona_Posio_Ponto
                End If
               Case 11
                Posio = Posio + 10
                If Consulta_Projeto(Nmero_Varivel) = True Then
                   Print #1, Tab(Posio); 1;
                Else
                  Print #1, Tab(Posio); 0;
               End If
              End Select
           Else
              Select Case VarType(Consulta_Alternativa(Nmero_Varivel - 104))
               Case 0, 1
                Posio = Posio + 10
                Print #1, Tab(Posio); " ?";
               Case 2
                If Consulta_Alternativa(Nmero_Varivel - 104) = -32768 Then
                   Posio = Posio + 10
                   Print #1, Tab(Posio); " ?";
                Else
                   Posio = Posio + 10
                   Print #1, Tab(Posio); Consulta_Alternativa(Nmero_Varivel - 104);
                End If
               Case 6
                If Consulta_Alternativa(Nmero_Varivel - 104) = -32768 Then
                   Posio = Posio + 10
                   Print #1, Tab(Posio); " ?";
                Else
                   Varivel_Posicional = Consulta_Alternativa(Nmero_Varivel - 104)
                   Seleciona_Posio_Ponto
                End If
               Case 11
                Posio = Posio + 10
                If Consulta_Alternativa(Nmero_Varivel - 104) = True Then
                   Print #1, Tab(Posio); 1;
                Else
                   Print #1, Tab(Posio); 0;
                End If
               End Select
           End If
        End If
    Next
 End If
End Sub
'-----------------------------------------------------------------------------'
'      02.2.g.3. GRAVAO DOS REGISTROS DE SAIDA DOS PROJETOS/ALTERNATIVAS    '
'-----------------------------------------------------------------------------'
Sub Grava_Dados_Sada_Tti()
 Dim I%
 Dim Prioridade As Integer
 Prioridade = Tabela_C_01_Aux!IND_PRIORIDADE
 If Tipo_Partio_Aux = 1 Or Tipo_Partio_Aux = 2 Then
    If Tipo_Servio = 2 Then
       For I = 1 To 12
           Verifica_ltima_Posio
           If I% = Prioridade Then
              Posio = Posio + 10
              Print #1, Tab(Posio); Prioridade
           End If
       Next
    Else
       For I = 1 To 12
           Verifica_ltima_Posio
           Posio = Posio + 10
           If I% = Prioridade Then
              If I% = 12 Then
                 Print #1, Tab(Posio); 1
              Else
                 Print #1, Tab(Posio); 1;
              End If
           Else
              If I% = 12 Then
                 Print #1, Tab(Posio); 0
              Else
                 Print #1, Tab(Posio); 0;
              End If
           End If
       Next
    End If
 Else
    If Tipo_Servio = 2 Or Tipo_Servio = 15 Or Tipo_Servio = 23 Then
       Verifica_ltima_Posio
       Posio = Posio + 10
       Print #1, Tab(Posio); " ?"
    Else
       For I = 1 To 11
           Verifica_ltima_Posio
           Posio = Posio + 10
           Print #1, Tab(Posio); " ?";
       Next
       Verifica_ltima_Posio
       Posio = Posio + 10
       Print #1, Tab(Posio); " ?"
    End If
 End If
End Sub
'-----------------------------------------------------------------------------'
'      02.2.h. GRAVAO DE DADOS DAS SECAO 5 - LIMITES DE NORMALIZAO        '
'-----------------------------------------------------------------------------'
'-----------------------------------------------------------------------------'
'              02.2.h.1. GRAVAO DOS DADOS PARA TODAS AS VARIVEIS           '
'-----------------------------------------------------------------------------'
Sub Grava_Limites_Normalizao_Tti()
 Dim I%
 Abre_Tabela_D_01
 Posio = 10
 If St_Seleo_Todos = True Then
    Print #1, " [HIGHS]";
    Do Until Tabela_D_01.EOF
       Verifica_ltima_Posio
       Varivel_Posicional = Tabela_D_01!LIM_MXIMO
       Seleciona_Posio_Ponto
       Tabela_D_01.MoveNext
    Loop
    Select Case Tipo_Servio
    Case 2, 15, 17, 23
       Posio = Posio + 10
       Print #1, Tab(Posio); 12
    Case 3, 16, 18, 24
       For I = 1 To 11
           Posio = Posio + 10
           Print #1, Tab(Posio); 1;
       Next
       Posio = Posio + 10
       Print #1, Tab(Posio); 1
    End Select
    Print #1, " [LOWS]";
    Posio = 10
    Tabela_D_01.MoveFirst
    Do Until Tabela_D_01.EOF
       Verifica_ltima_Posio
       Varivel_Posicional = Tabela_D_01!LIM_MNIMO
       Seleciona_Posio_Ponto
       Tabela_D_01.MoveNext
    Loop
    Select Case Tipo_Servio
    Case 2, 15, 17, 23
       Posio = Posio + 10
       Print #1, Tab(Posio); 1
    Case 3, 16, 18, 24
       For I = 1 To 11
           Posio = Posio + 10
           Print #1, Tab(Posio); 0;
       Next
       Posio = Posio + 10
       Print #1, Tab(Posio); 0
    End Select
 Else
    Print #1, " [HIGHS]";
    Posio = 10
    Verifica_ltima_Posio
    For I = 1 To 240
        If Seleo_Variveis(I%, 1) = True Then
           Verifica_ltima_Posio
           Tabela_D_01.Seek "=", I%
           Varivel_Posicional = Tabela_D_01!LIM_MXIMO
         
           Seleciona_Posio_Ponto
        End If
    Next
    Select Case Tipo_Servio
     Case 2, 15, 17, 23
       Verifica_ltima_Posio
       Posio = Posio + 10
       Print #1, Tab(Posio); 12
    Case 3, 16, 18, 24
       For I = 1 To 11
            Verifica_ltima_Posio
           Posio = Posio + 10
           Print #1, Tab(Posio); 1;
       Next
       Verifica_ltima_Posio
       Posio = Posio + 10
       Print #1, Tab(Posio); 1
  End Select
    Print #1, " [LOWS]";
    Posio = 10
    Verifica_ltima_Posio
    For I = 1 To 240
         If Seleo_Variveis(I%, 1) = True Then
           Verifica_ltima_Posio
           Tabela_D_01.Seek "=", I%
           Varivel_Posicional = Tabela_D_01!LIM_MNIMO
           Seleciona_Posio_Ponto
        End If
    Next
    Select Case Tipo_Servio
    Case 2, 15, 17, 23
       Verifica_ltima_Posio
       Posio = Posio + 10
       Print #1, Tab(Posio); 1
    Case 3, 16, 18, 24
       For I = 1 To 11
             Verifica_ltima_Posio
           Posio = Posio + 10
           Print #1, Tab(Posio); 0;
       Next
       Verifica_ltima_Posio
       Posio = Posio + 10
       Print #1, Tab(Posio); 0
    End Select
 End If
 Print #1, "[END]"
 Print #1, String(1021, "-")
 Print #1, "                             FIM DO ARQUIVO"
 Print #1, _
  "   ESTE ARQUIVO FOI GERADO COM " & Contador & " VARIAVEIS DE ENTRADA/SAIDA"
 Print #1, String(1021, "-")
End Sub
'-----------------------------------------------------------------------------'
'                                FIM DO MDULO 2                              '
'-----------------------------------------------------------------------------'





      






    



















Sub Grava_Resultado()
 Dim Prioridade As Integer
 Dim Prioridade_Auxiliar As Integer
 Dim Prioridade_Anterior As Integer
 Open String_Pesquisa_2 For Output As #2
 Print #2, String(1021, "-")
 Print #2, "     EVALUATOR"
 Print #2, "     ARQUIVO DE RESULTADOS DE AVALIAO E ORDENAMENTO"
 Print #2, "     Desenvolvido por: Nilder Furtado/Eiji Kawamoto"
 Print #2, "     Data/Horario da Criacao: "; Date; Time
 Print #2, String(1021, "-")
 Print #2, ""
 Print #2, ""
 Print #2, "     PROJETO CONSIDERADO: "; Cod_Projeto_Anterior
 Print #2, "     DESCRIO DESTE PROJETO: "; Desc_Projeto_Aux
 Print #2, "     NMERO DE ALTERNATIVAS CONSIDERADAS: "; Contador_Alternativas
 Print #2, "     ARQUIVO DE RESULTADO DE ICR CONSIDERADO: "; String_Pesquisa_1
 Print #2, ""
 Print #2, ""
 Print #2, "     RESULTADOS FINAIS DA AVALIAO"
 Tabela_G_01.Close
 For I% = 1 To 12
     Ordenamento(I%) = 0
 Next
 Abre_Tabela_G_01
 Tabela_G_01.MoveFirst
 Do Until Tabela_G_01.EOF
    Print #2, "       * Alternativa Considerada: "; Tabela_G_01!COD_ALTERNATIVA
    If Len(Tabela_G_01!Ordem) > 2 Then
       Prioridade = Prioridade + 1
       Print #2, "           Prioridade para esta Alternativa: "; Prioridade
    Else
       Prioridade_Auxiliar = Fix(Tabela_G_01!Ordem / 10)
       If Prioridade_Anterior <> Prioridade_Auxiliar Then
          Prioridade_Anterior = Prioridade_Auxiliar
          Prioridade = Prioridade + 1
       End If
       Print #2, "           Prioridade para esta Alternativa: "; Prioridade
    End If
       Print #2, "           ndice para esta Alternativa obtido nas RNA: "; Tabela_G_01!Ordem
    Tabela_G_01.MoveNext
 Loop
 Tabela_G_01.Close
 Print #2, ""
 Print #2, ""
 If Contador_Alternativas <> Contador Then
    Print #2, "     A(s) Alternativa(s) no mostrada(s) foi(ram) considerada(s) invivel(eis) "
 End If
 Contador_Alternativas = 0
 Contador = 0
 Print #2, String(1021, "-")
 Print #2, "     FIM DESTE ARQUIVO DE RESULTADOS"
 Print #2, String(1021, "-")
 Close #2
End Sub

Sub Ordena_Resultados()
 Dim DB As Database
 Dim Tabela_G_01 As TableDef
 Dim Ordem As Field
 Dim Contagem As Field
 Dim Alternativa As Field
 Dim Chave As Index
 Dim ndice As Field
 Set DB = DBEngine.Workspaces(0).OpenDatabase("C:\EVALUATOR\BDEVAL.MDB")
 Set Tabela_G_01 = DB.CreateTableDef("TABELA-G-01")
 Set Ordem = Tabela_G_01.CreateField("ORDEM", dbCurrency)
 Set Contagem = Tabela_G_01.CreateField("CONTAGEM", dbInteger)
 Set Alternativa = Tabela_G_01.CreateField("COD_ALTERNATIVA", dbInteger)
 Set Chave = Tabela_G_01.CreateIndex("PrimaryKey")
 Chave.Primary = True
 Chave.Unique = True
 Set ndice = Chave.CreateField("ORDEM")
 Chave.Fields.Append ndice
 Tabela_G_01.Indexes.Append Chave
 Tabela_G_01.Fields.Append Ordem
 Tabela_G_01.Fields.Append Contagem
 Tabela_G_01.Fields.Append Alternativa
 DB.TableDefs.Append Tabela_G_01
 Abre_Tabela_G_01
 For I% = 1 To 12
     For J% = 1 To 12
         If Prioridades_Resultado(I%, J%, 1) <> 0 Then
            Contador = Contador + 1
            Inclui_Tabela_G_01
         End If
     Next
 Next
 Grava_Resultado
 DB.TableDefs.Delete "TABELA-G-01"
End Sub

Sub Seleciona_Posio_Ponto()
 Posio = Posio + 10
 Select Case Len(Varivel_Posicional)
  Case 0, 1, 2
    Print #1, Tab(Posio); Varivel_Posicional;
  Case 3
    If Varivel_Posicional > 0 Then
       If Varivel_Posicional < 10 Then
          Mid(Varivel_Posicional, 2, 1) = "."
          Print #1, Tab(Posio + 1); Varivel_Posicional;
          Exit Sub
       Else
          Print #1, Tab(Posio); Varivel_Posicional;
          Exit Sub
       End If
    Else
       Print #1, Tab(Posio); Varivel_Posicional;
       Exit Sub
    End If
  Case 4
    If Varivel_Posicional > 0 Then
     If Varivel_Posicional < 10 Then
       Mid(Varivel_Posicional, 2, 1) = "."
       Print #1, Tab(Posio + 1); Varivel_Posicional;
       Exit Sub
     Else
       If Varivel_Posicional < 100 Then
          Mid(Varivel_Posicional, 3, 1) = "."
          Print #1, Tab(Posio + 1); Varivel_Posicional;
          Exit Sub
       Else
          Print #1, Tab(Posio); Varivel_Posicional;
          Exit Sub
       End If
     End If
    Else
     If Varivel_Posicional > -10 Then
        Mid(Varivel_Posicional, 3, 1) = "."
          Print #1, Tab(Posio + 1); Varivel_Posicional;
          Exit Sub
     Else
        Print #1, Tab(Posio + 1); Varivel_Posicional;
          Exit Sub
     End If
   End If
  Case 5
     If Varivel_Posicional > 0 Then
     If Varivel_Posicional < 100 Then
        Mid(Varivel_Posicional, 3, 1) = "."
        Print #1, Tab(Posio + 1); Varivel_Posicional;
        Exit Sub
     Else
       If Varivel_Posicional < 10000 Then
          Mid(Varivel_Posicional, 4, 1) = "."
          Print #1, Tab(Posio + 1); Varivel_Posicional;
          Exit Sub
       Else
          Print #1, Tab(Posio); Varivel_Posicional;
          Exit Sub
       End If
     End If
    Else
     If Varivel_Posicional > -10 Then
        Mid(Varivel_Posicional, 3, 1) = "."
        Print #1, Tab(Posio + 1); Varivel_Posicional;
        Exit Sub
     Else
        If Varivel_Posicional > -100 Then
           Mid(Varivel_Posicional, 4, 1) = "."
           Print #1, Tab(Posio + 1); Varivel_Posicional;
           Exit Sub
        Else
        Print #1, Tab(Posio); Varivel_Posicional;
          Exit Sub
       End If
      End If
     End If
  Case 6
     If Varivel_Posicional > 0 Then
     If Varivel_Posicional < 1000 Then
        Mid(Varivel_Posicional, 4, 1) = "."
        Print #1, Tab(Posio + 1); Varivel_Posicional;
        Exit Sub
     Else
       If Varivel_Posicional < 10000 Then
          Mid(Varivel_Posicional, 5, 1) = "."
          Print #1, Tab(Posio + 1); Varivel_Posicional;
          Exit Sub
       Else
          Print #1, Tab(Posio); Varivel_Posicional;
          Exit Sub
    End If
   End If
   Else
    If Varivel_Posicional > -100 Then
     Mid(Varivel_Posicional, 4, 1) = "."
        Print #1, Tab(Posio + 1); Varivel_Posicional;
        Exit Sub
    
    Else
     If Varivel_Posicional > -1000 Then
        Mid(Varivel_Posicional, 5, 1) = "."
        Print #1, Tab(Posio + 1); Varivel_Posicional;
        Exit Sub
     Else
      Print #1, Tab(Posio); Varivel_Posicional;
          Exit Sub
    End If
    End If
    End If
  Case 7
   If Varivel_Posicional > 0 Then
      If Varivel_Posicional < 10000 Then
         Mid(Varivel_Posicional, 5, 1) = "."
         Print #1, Tab(Posio + 1); Varivel_Posicional;
         Exit Sub
      Else
         If Varivel_Posicional < 100000 Then
            Mid(Varivel_Posicional, 6, 1) = "."
            Print #1, Tab(Posio + 1); Varivel_Posicional;
            Exit Sub
         Else
            Print #1, Tab(Posio); Varivel_Posicional;
            Exit Sub
         End If
      End If
   Else
      If Varivel_Posicional > -1000 Then
         Mid(Varivel_Posicional, 5, 1) = "."
         Print #1, Tab(Posio + 1); Varivel_Posicional;
         Exit Sub
      Else
         If Varivel_Posicional > -10000 Then
            Mid(Varivel_Posicional, 6, 1) = "."
            Print #1, Tab(Posio + 1); Varivel_Posicional;
            Exit Sub
         Else
            Print #1, Tab(Posio); Varivel_Posicional;
            Exit Sub
         End If
      End If
   End If
    
  Case 8
     If Varivel_Posicional > 0 Then
     If Varivel_Posicional < 100000 Then
        Mid(Varivel_Posicional, 6, 1) = "."
        Print #1, Tab(Posio + 1); Varivel_Posicional;
        Exit Sub
     Else
        Print #1, Tab(Posio); Varivel_Posicional;
     End If
     Else
       If Varivel_Posicional > -10000 Then
       Mid(Varivel_Posicional, 6, 1) = "."
         Print #1, Tab(Posio + 1); Varivel_Posicional;
         Exit Sub
      Else
         If Varivel_Posicional > -100000 Then
            Mid(Varivel_Posicional, 7, 1) = "."
            Print #1, Tab(Posio + 1); Varivel_Posicional;
            Exit Sub
         Else
            Print #1, Tab(Posio); Varivel_Posicional;
            Exit Sub
         End If
      End If
   End If
   Case 9
    If variavel_posicional > 0 Then
      If Varivel_Posicional < 1000000 Then
         Mid(Varivel_Posicional, 7, 1) = "."
         Print #1, Tab(Posio + 1); Varivel_Posicional;
         Exit Sub
      Else
            Print #1, Tab(Posio); Varivel_Posicional;
            Exit Sub
      End If
   Else
      If Varivel_Posicional > -100000 Then
         Mid(Varivel_Posicional, 7, 1) = "."
         Print #1, Tab(Posio + 1); Varivel_Posicional;
         Exit Sub
      Else
         If Varivel_Posicional > -1000000 Then
            Mid(Varivel_Posicional, 8, 1) = "."
            Print #1, Tab(Posio + 1); Varivel_Posicional;
            Exit Sub
         Else
            Print #1, Tab(Posio); Varivel_Posicional;
            Exit Sub
         End If
      End If
   End If
 End Select

End Sub
Sub Verifica_ICR()
 Dim I%
 Dim Sequencial As Integer
 Dim Registro_Aux As String * 2
 Dim Registro As String
 Dim Registro_Caso As String
 Open String_Pesquisa_1 For Input As #1
 Open "C:\EVALUATOR\RESULTS\" & Arquivo & ".ICR" For Output As #2
 Nmero_Ocorrncias = 3000
 Set Form = F000000
 Chama_Progresso
 Do While Not EOF(1)
    Chama_Progresso_1
    Input #1, Registro
    Registro_Aux = Registro
    Select Case Registro_Aux
     Case "Ca"
         Registro_Caso = Registro
     Case "IP", "IO"
         If Len(Registro) = 25 Then
             Print #2, Registro; Tab(40); Registro_Caso
         Else
             Print #2, Registro; Tab(40); Registro_Caso
         End If
     End Select
 Loop
 Print #2, _
       "99999999999999999999999999999999999999999999999999999999999999999999"
 Close #1
 Close #2
End Sub

Sub Verifica_ICR_1()
 Dim Chave_Pesquisa As String
 Open "C:\EVALUATOR\RESULTS\" & Arquivo & ".ICR" For Random As #1 Len = 62
 Abre_Consulta_Alternativa
 Dim Registro_Aux As String * 2
 Get #1, , Registro_1
 Cod_Projeto_Anterior = 0
 Cod_Alternativa_Anterior = 0
 Cod_Projeto_Aux = Registro_1.Campo_6
 Cod_Alternativa_Aux = Registro_1.Campo_8
 Tipo_de_ndice = Registro_1.Campo_1
 For I% = 1 To 999
     IDPR(I%, 1) = 0
     Chama_Progresso_1
 Next
 IDR_Aux = 0
 Contador_Projetos = 0
 Contador_Alternativas = 0
 Prioridade_Obtida = 0
 Prioridade_Prevista = 0
 IDR = 0
 ICR = 0
 NMAR = 0
 Soma_de_Prioridades = 0
  Do While Registro_1.Campo_6 < "999"
    Chama_Progresso_1
    If Cod_Projeto_Anterior <> Cod_Projeto_Aux Then
       Contador_Projetos = Contador_Projetos + 1
    End If
    Cod_Projeto_Anterior = Cod_Projeto_Aux
    SearchString = Registro_1.Campo_4
    SearchChar = "e-"
    If tipo_ndice = "IOA" Then  'novo
       If InStr(1, SearchString, SearchChar, 1) Then
          Prioridade_Obtida = 0
       Else
          SearchString = Registro_1.Campo_4
          SearchChar = "0 "
          If InStr(1, SearchString, SearchChar, 1) Then
             Prioridade_Obtida = 0
          Else
             SearchString = Registro_1.Campo_4
             SearchChar = "1 "
             If InStr(1, SearchString, SearchChar, 1) Then
                 Prioridade_Obtida = Registro_1.Campo_3
             End If 'novo
          End If 'novo       Else
       End If 'novo
     Else 'novo
          Determina_Prioridade
     'novo     End If
    'novo   End If
    End If
    Consulta_Alternativa.MoveFirst
    Do Until Consulta_Alternativa.EOF
       If Cod_Projeto_Aux = Consulta_Alternativa!Cod_Projeto Then
          If Cod_Alternativa_Aux = Consulta_Alternativa!COD_ALTERNATIVA Then
             Prioridade_Prevista = Consulta_Alternativa!IND_PRIORIDADE
             If Prioridade_Obtida <> 0 Then
                IDPR(Cod_Projeto_Aux, 1) = IDPR(Cod_Projeto_Aux, 1) + (Prioridade_Obtida / Prioridade_Prevista)
                Soma_de_Prioridades = Soma_de_Prioridades + Prioridade_Obtida
                Prioridade_Obtida = 0
                If Chave_Pesquisa <> Consulta_Alternativa!Cod_Projeto & Consulta_Alternativa!COD_ALTERNATIVA Then
                   Contador_Alternativas = Contador_Alternativas + 1
                   Chave_Pesquisa = Cod_Projeto_Aux & Cod_Alternativa_Aux
                   Exit Do
                End If
             End If
          End If
       End If
       Consulta_Alternativa.MoveNext
    Loop
    Get #1, , Registro_1
    Cod_Projeto_Aux = Registro_1.Campo_6
    Cod_Alternativa_Aux = Registro_1.Campo_8
    Loop

 For I% = 1 To 999
     IDR_Aux = IDR_Aux + IDPR(I%, 1)
     Chama_Progresso_1
 Next
 Finaliza_Progresso
 IDR = IDR_Aux / Contador_Projetos
 NMAR = Contador_Alternativas / Contador_Projetos
 ICR = IDR / NMAR
 Close #1
 Open "C:\EVALUATOR\RESULTS\" & Arquivo & ".ICR" For Append As #1 Len = 57
 Print #1, String(1021, "-")
 Print #1, Tab(2); "ICR DESTA REDE PARA O ARQUIVO DE SIMULACAO (" & String_Pesquisa_1 & ") = "; ICR
 Print #1, Tab(2); "INDICE DE DESEMPENHO VERIFICADO EM: "; Date; Time
 Print #1, String(1021, "-")
 Close #1
 Consulta_Alternativa.Close
End Sub
Sub Verifica_ltima_Posio()
    If Posio >= 1010 Then
       Posio = 10
    End If
End Sub

