Attribute VB_Name = "Module1"
'-------------------------------------------------------------------------------'
'                            UNIVERSIDADE DE SO PAULO                          '
'                        ESCOLA DE ENGENHARIA DE SO CARLOS                     '
'                           DEPARTAMENTO DE TRANSPORTES                         '
'                             REA DE PS-GRADUAO                             '
'                                                                               '
'                         PROGRAMA EVALUATOR PARA WINDOWS                       '
'       INTERFACE PARA AVALIAO E ORDENAMENTO DE PROJETOS DE TRANSPORTE        '
'                      COM O USO DAS REDES NEURAIS ARTIFICIAIS                  '
'                                                                               '
'                       VERSO 1.00 - DESENVOLVIDA EM 01/01/98                  '
'                         POR: NILDER FURTADO/EIJI KAWAMOTO                     '
'-------------------------------------------------------------------------------'

'-------------------------------------------------------------------------------'
'                    MDULO 1 -  SERVIO DE BANCO DE DADOS                      '
'                                                                               '
'  Este Mdulo Controla todas as atividades e rotinas do servio de banco de    '
'  dados: incluir/alterar/excluir/consultar/imprimar dados de projetos/alter-   '
'  nativas alm da possibilidade de manuteno das tabelas gerenciadas neste    '
'  programa e da definio de usurios e senhas que podem acessar/alterar  o    '
'  Banco de Dados.  O Banco de Dados foi definido no "Access 97" estando com-   '
'  composto por um conjunto de ENTIDADES/RELACIONAMENTOS, de forma a caracte-   '
'  rizar as variveis de avaliao e deciso relacionadas com um contexto es-   '
'  pecfico.
'-------------------------------------------------------------------------------'

'-------------------------------------------------------------------------------'
'      01. DEFINIO DAS VARIVEIS GLOBAIS PARA AS FUNES DO BANCO DE DADOS    '
'  St_Seleo_Todos = Controle que determina se todas as variveis sero uti-   '
'                     lizadas para gerar o arquivo "TTI". Caso este controle    '
'                     seja "false", nem todas as variveis foram selecionadas.  '
'  Contador = Define o Nmero de Variveis a serem includas no arquivo "TTI".  '
'  Contador_Aux = Acumula o valor do Contador para que o mesmo sirva de refe-   '
'                 rncia para as parties de treinamento, validao ou teste.  '
'  St_Varivel_999 (1)= Controle que determina se uma determinada varivel foi  '
'                       ou no selecionada para gerar o arquivo "TTI".          '
'                       (1): onde 999  o nmero da varivel                    '
'-------------------------------------------------------------------------------'

Public Senha_Aux As String * 5
Public Contador_Registros_Aux
Public Tipo_Consulta As Integer


Public Registros_Treinamento As Integer
Public Registros_Validao As Integer
Public Registros_Teste As Integer
Public Registros_Treinamento_Aux As Integer
Public Registros_Validao_Aux As Integer
Public Registros_Teste_Aux As Integer
Public Tipo_Padro As Integer




 Public Type Registro_Aleatrio
   Aleatrio As Currency
   Cod_Projeto As Integer
   Avaliao As Integer
 End Type
 Dim Registro_1 As Registro_Aleatrio
 
 Private Type Registro_Particionado
   Tipo_Partio As String * 3
   Cod_Projeto As Integer
   Aleatrio As Currency
   
   Avaliao As Integer
 End Type
 Dim Registro_2 As Registro_Particionado


Public Num_Aleatrio_Aux As Long


Public St_Grava_Registro_Tabela_A_01 As Boolean
Public St_Grava_Registro_Tabela_B_01 As Boolean
Public St_Alterao_Todos_1 As Boolean
Public St_Alterao_Desc_Projeto As Boolean
Public St_Alterao_Am_Piloto As Boolean
Public St_Alterao_Est_Projeto As Boolean
Public St_Alterao_Data_Avaliao As Boolean
Public St_Alterao_Num_Alternativas As Boolean
Public St_Alterao_St_Avaliao As Boolean
Public St_Alterao_Tec_Avaliao As Boolean
Public St_Alterao_Tipo_Projeto As Boolean
Public St_Alterao_Map_Situao As Boolean
Public St_Alterao_Map_Localizao As Boolean
Public St_Meta_1 As Boolean
Public St_Meta_2 As Boolean
Public St_Meta_3 As Boolean
Public St_Meta_4 As Boolean
Public sT_GRAVA_TODAS As Boolean












Public BD As Database
Public Tabela_A_01 As Recordset
Public Tabela_A_01_01 As Recordset
Public Tabela_A_01_01_Aux As Recordset
Public Tabela_A_01_02 As Recordset
Public Tabela_A_01_02_Aux As Recordset
Public Tabela_A_01_03 As Recordset
Public Tabela_A_01_03_Aux As Recordset
Public Tabela_A_01_04 As Recordset
Public Tabela_A_01_04_Aux As Recordset
Public Tabela_B_01 As Recordset
Public Tabela_B_01_01 As Recordset
Public Tabela_B_01_01_Aux As Recordset
Public Tabela_B_02_01 As Recordset
Public Tabela_B_02_02 As Recordset
Public Tabela_B_02_03 As Recordset
Public Tabela_B_02_04 As Recordset
Public Tabela_B_03_01 As Recordset
Public Tabela_C_01 As Recordset
Public Tabela_C_01_Aux As Recordset


Public Tabela_F_01 As Recordset





Public Tipo_Operao As Integer

Public Tipo_Servio As Integer





Public Nvel_Plan_Aux As Integer
Public Est_Projeto_1_Aux As String

Public Cod_Projeto_Aux As Integer
Public Est_Projeto_Aux As String
Public Data_Avaliao_Aux As Integer
Public Num_Alternativas_Aux As Integer
Public Cod_St_Avaliao_Aux As Integer
Public Tec_Avaliao_Aux As Integer
Public Am_Piloto_Aux As Boolean
Public Tipo_Projeto_Aux As Integer
Public Map_Situao_Aux As Object
Public Map_Localizao_Aux As Object

Public Fator_1_Aux As Boolean
Public Fator_2_Aux As Boolean
Public Fator_3_Aux As Boolean
Public Fator_4_Aux As Boolean
Public Nvel_Plan_1_Aux As String
Public Rel_Facilidades_Aux As Long

Public Crit_2111_Aux As Boolean
Public Crit_2112_Aux As Boolean
Public Crit_2113_Aux As Boolean
Public Crit_2114_Aux As Boolean
Public Crit_2121_Aux As Boolean
Public Crit_2122_Aux As Boolean
Public Crit_2131_Aux As Boolean
Public Crit_2132_Aux As Boolean
Public Crit_2133_Aux As Boolean

Public Crit_2211_Aux As Boolean
Public Crit_2212_Aux As Boolean
Public Crit_2213_Aux As Boolean
Public Crit_2214_Aux As Boolean
Public Crit_2215_Aux As Boolean
Public Crit_2216_Aux As Boolean
Public Crit_2221_Aux As Boolean
Public Crit_2222_Aux As Boolean
Public Crit_2223_Aux As Boolean
Public Crit_2224_Aux As Boolean
Public Crit_2225_Aux As Boolean
Public Crit_2226_Aux As Boolean
Public Crit_2231_Aux As Boolean
Public Crit_2232_Aux As Boolean
Public Crit_2241_Aux As Boolean
Public Crit_2242_Aux As Boolean
Public Crit_2243_Aux As Boolean

Public Crit_2311_Aux As Boolean
Public Crit_2312_Aux As Boolean
Public Crit_2321_Aux As Boolean
Public Crit_2322_Aux As Boolean
Public Crit_2331_Aux As Boolean
Public Crit_2332_Aux As Boolean
Public Crit_2233_Aux As Boolean

Public Crit_2411_Aux As Boolean
Public Crit_2412_Aux As Boolean
Public Crit_2413_Aux As Boolean
Public Crit_2421_Aux As Boolean
Public Crit_2422_Aux As Boolean

Public Brancos_Aux As Integer
Public Pretos_Aux As Integer
Public ndios_Aux As Integer
Public Hispnicos_Aux As Integer
Public Outras_Raas_Aux As Integer
Public Zero_6_Anos_Aux As Integer
Public De_7_21_Anos_Aux As Integer
Public De_21_65_Anos_Aux As Integer
Public Mais_65_Anos_Aux As Integer
Public Tx_Populacional_Aux As Integer
Public Tx_Habitacional_Aux As Integer
Public Tx_Econmico_Aux As Integer
Public Agrcola_Aux As Integer
Public Industrial_Aux As Integer
Public Comercial_Aux As Integer
Public Servios_Aux As Integer
Public Seg_Racial_Aux As Integer
Public Seg_Baixa_Renda_Aux As Integer
Public Seg_Def_Fsica_Aux As Integer
Public Seg_Etria_Aux As Integer
Public Nvel_Renda_Aux As Integer

Public Efetividade_Aux As Integer
Public Prioridade_Aux As Integer






















Public Tipo_Gerao_Partio As Integer
Public Treinamento As Boolean
Public Validao As Boolean
Public Teste As Boolean
Public Treinamento_Aux As Boolean
Public Validao_Aux As Boolean
Public Teste_Aux As Boolean



       
Public Cod_Alternativa_Aux As Integer

Public Desc_Projeto_Aux As String




'--------------------------------------------------
' VARIVEIS DE CONTAGEM PERCENTUAL PARA CONSULTAS
'--------------------------------------------------
Public Tipo_Projeto_1 As Long
Public Tipo_Projeto_2 As Long
Public Tipo_Projeto_3 As Long
Public Tipo_Projeto_4 As Long
Public Tipo_Projeto_5 As Long
Public Tipo_Projeto_6 As Long
Public Tipo_Projeto_7 As Long
Public Tipo_Projeto_8 As Long
Public Tipo_Projeto_9 As Long
Public Tipo_Projeto_10 As Long
Public Tipo_Projeto_11 As Long
Public Tipo_Projeto_12 As Long
Public Tipo_Projeto_13 As Long
Public Tipo_Projeto_14 As Long
Public Tipo_Projeto_15 As Long
Public Tipo_Projeto_16 As Long

Public Tec_Tipo_1 As Long
Public Tec_Tipo_2 As Long
Public Tec_Tipo_3 As Long
Public Tec_Tipo_4 As Long
Public Tec_Tipo_5 As Long
Public Tec_Tipo_6 As Long
Public Tec_Tipo_7 As Long
Public Tec_Tipo_8 As Long

Public Data_1 As Long
Public Data_2 As Long
Public Data_3 As Long
Public Data_4 As Long
Public Data_5 As Long

Public Num_Alternativas_1 As Long
Public Num_Alternativas_2 As Long
Public Num_Alternativas_3 As Long




Public Contador_Registros As Integer
Public Contador_Alteraes As Integer
Public Contador_Alteraes_Aux As Integer


Public Status_Tipo_1 As Long
Public Status_Tipo_2 As Long
Public Status_Tipo_3 As Long
Public Tipo_Consulta_Percentual As Integer

Public Indicador_Status_Tipo_1 As Integer
Public Indicador_Status_Tipo_2 As Integer
Public Indicador_Status_Tipo_3 As Integer

Public Indicador_Tipo_Projeto_1 As Integer
Public Indicador_Tipo_Projeto_2 As Integer
Public Indicador_Tipo_Projeto_3 As Integer
Public Indicador_Tipo_Projeto_4 As Integer
Public Indicador_Tipo_Projeto_5 As Integer
Public Indicador_Tipo_Projeto_6 As Integer
Public Indicador_Tipo_Projeto_7 As Integer
Public Indicador_Tipo_Projeto_8 As Integer
Public Indicador_Tipo_Projeto_9 As Integer
Public Indicador_Tipo_Projeto_10 As Integer
Public Indicador_Tipo_Projeto_11 As Integer
Public Indicador_Tipo_Projeto_12 As Integer
Public Indicador_Tipo_Projeto_13 As Integer
Public Indicador_Tipo_Projeto_14 As Integer
Public Indicador_Tipo_Projeto_15 As Integer
Public Indicador_TIpo_Projeto_16 As Integer

Public Indicador_Tcnica_1 As Integer
Public Indicador_Tcnica_2 As Integer
Public Indicador_Tcnica_3 As Integer
Public Indicador_Tcnica_4 As Integer
Public Indicador_Tcnica_5 As Integer
Public Indicador_Tcnica_6 As Integer
Public Indicador_Tcnica_7 As Integer
Public Indicador_Tcnica_8 As Integer

Public Indicador_Data_1 As Integer
Public Indicador_Data_2 As Integer
Public Indicador_Data_3 As Integer
Public Indicador_Data_4 As Integer
Public Indicador_Data_5 As Integer

Public Indicador_Nmero_Alt_1 As Integer
Public Indicador_Nmero_Alt_2 As Integer
Public Indicador_Nmero_Alt_3 As Integer









 
   
'-------------------------------------------------------
'PARTE B
'ABERTURA DAS TABELAS DO BANCO DE DADOS (ACCESS)
'-------------------------------------------------------


Sub Abre_Tabela_A_01()
 Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_A_01 = BD.OpenRecordset("Tabela-A-01", dbOpenTable)
 Tabela_A_01.Index = "PrimaryKey"
End Sub

    




Sub Abre_Tabela_A_01_01()
 Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_A_01_01 = BD.OpenRecordset("Tabela-A-01-01", dbOpenTable)
 Tabela_A_01_01.Index = "Nome_do_Estado"

End Sub


Sub Abre_Tabela_A_01_01_Aux()
Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_A_01_01_Aux = BD.OpenRecordset("Tabela-A-01-01", dbOpenTable)
 Tabela_A_01_01_Aux.Index = "PrimaryKey"

End Sub


Sub Abre_Tabela_A_01_02()
 Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_A_01_02 = BD.OpenRecordset("Tabela-A-01-02", dbOpenTable)
 Tabela_A_01_02.Index = "Nome_Tcnica"

End Sub


Sub Abre_Tabela_A_01_02_Aux()
Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_A_01_02_Aux = BD.OpenRecordset("Tabela-A-01-02", dbOpenTable)
 Tabela_A_01_02_Aux.Index = "PrimaryKey"

End Sub


Sub Abre_Tabela_A_01_03()
 Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_A_01_03 = BD.OpenRecordset("Tabela-A-01-03", dbOpenTable)
 Tabela_A_01_03.Index = "Nome_Tipo"
 
End Sub


Sub Abre_Tabela_A_01_03_Aux()
Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_A_01_03_Aux = BD.OpenRecordset("Tabela-A-01-03", dbOpenTable)
 Tabela_A_01_03_Aux.Index = "PrimaryKey"
End Sub


Sub Abre_Tabela_A_01_04()
 Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_A_01_04 = BD.OpenRecordset("Tabela-A-01-04", dbOpenTable)
 Tabela_A_01_04.Index = "Nome_St_Avaliao"
End Sub


Sub Abre_Tabela_A_01_04_Aux()

 Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_A_01_04_Aux = BD.OpenRecordset("Tabela-A-01-04", dbOpenTable)
 Tabela_A_01_04_Aux.Index = "PrimaryKey"
End Sub


Sub Abre_Tabela_B_01()
Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_B_01 = BD.OpenRecordset("Tabela-B-01", dbOpenTable)
 Tabela_B_01.Index = "PrimaryKey"
End Sub

Sub Abre_Tabela_B_01_01()
 Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_B_01_01 = BD.OpenRecordset("Tabela-B-01-01", dbOpenTable)
 Tabela_B_01_01.Index = "NOME_ABORDAGEM"
End Sub



Sub Abre_Tabela_B_01_01_Aux()
 Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_B_01_01_Aux = BD.OpenRecordset("Tabela-B-01-01", dbOpenTable)
 Tabela_B_01_01_Aux.Index = "PrimaryKey"
End Sub


Sub Abre_Tabela_B_02_01()
 Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_B_02_01 = BD.OpenRecordset("Tabela-B-02-01", dbOpenTable)
 Tabela_B_02_01.Index = "PrimaryKey"
End Sub

Sub Abre_Tabela_B_02_02()
Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_B_02_02 = BD.OpenRecordset("Tabela-B-02-02", dbOpenTable)
 Tabela_B_02_02.Index = "PrimaryKey"
End Sub



Sub Abre_Tabela_B_02_03()
Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_B_02_03 = BD.OpenRecordset("Tabela-B-02-03", dbOpenTable)
 Tabela_B_02_03.Index = "PrimaryKey"
End Sub



Sub Abre_Tabela_B_02_04()
Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_B_02_04 = BD.OpenRecordset("Tabela-B-02-04", dbOpenTable)
 Tabela_B_02_04.Index = "PrimaryKey"
End Sub



Sub Abre_Tabela_B_03_01()
Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_B_03_01 = BD.OpenRecordset("Tabela-B-03-01", dbOpenTable)
 Tabela_B_03_01.Index = "PrimaryKey"
End Sub

Sub Abre_Tabela_C_01()
Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_C_01 = BD.OpenRecordset("Tabela-C-01", dbOpenTable)
 Tabela_C_01.Index = "PrimaryKey"
End Sub


Sub Abre_Tabela_C_01_Aux()
Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Tabela_C_01_Aux = BD.OpenRecordset("Tabela-C-01", dbOpenTable)
 Tabela_C_01_Aux.Index = "COD_PROJETO"
End Sub

Sub Abre_Tabela_F_01()
Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
Set Tabela_F_01 = BD.OpenRecordset("Tabela-F-01", dbOpenTable)
Tabela_F_01.Index = "PrimaryKey"
End Sub



Sub Complementa_Entradas_tti()
    
    If Contador_Aux > 14 Then
       Print #1, "          "; String(14, ">")
       Contador_Aux = Contador_Aux - 14
    Else
       If Contador_Aux > 14 Then
          Print #1, "          "; String(14, ">")
          Contador_Aux = Contador_Aux - 14
       Else
          If Contador_Aux > 14 Then
             Print #1, "         "; String(14, ">")
             Contador_Aux = Contador_Aux - 14
          Else
             If Contador_Aux > 14 Then
                Print #1, "          "; String(14, ">")
                Contador_Aux = Contador_Aux - 14
             Else
                If Contador_Aux > 14 Then
                   Print #1, "          "; String(14, ">")
                   Contador_Aux = Contador_Aux - 14
                Else
                   Print #1, "          "; String(Contador_Aux, ">")
                End If
             End If
          End If
       End If
    End If
End Sub

Sub Consulta_Tabela_A_01()
 Abre_Tabela_A_01
 Tabela_A_01.Seek "=", Cod_Projeto_Aux
End Sub

Sub Inclui_Tabela_A_01()
 Tabela_A_01.AddNew
 Tabela_A_01("Cod_Projeto") = Cod_Projeto_Aux
 Tabela_A_01("Desc_Projeto") = Desc_Projeto_Aux
 Tabela_A_01("Am_Piloto") = Am_Piloto_Aux
 Tabela_A_01("Est_Projeto") = Est_Projeto_Aux
 Tabela_A_01("DATA_AVALIAO") = Data_Avaliao_Aux
 Tabela_A_01("Num_Alternativas") = Num_Alternativas_Aux
 Tabela_A_01("ST_AVALIAO") = Cod_St_Avaliao_Aux
 Tabela_A_01("TEC_AVALIAO") = Tec_Avaliao_Aux
 Tabela_A_01("TIPO_PROJETO") = Tipo_Projeto_Aux
 Tabela_A_01("MAP_SITUAO") = Map_Situao_Aux
 Tabela_A_01("MAP_LOCALIZAO") = Map_Localizao_Aux
 Tabela_A_01.Update
 Tabela_A_01.Close
 MsgBox "REGISTRO INCLUDO COM SUCESSO NA TABELA-A-01", 48, "Registro Inserido"
End Sub







Sub Inclui_Tabela_B_01()
 Tabela_B_01.AddNew
 Tabela_B_01("Cod_Projeto") = Cod_Projeto_Aux
 Tabela_B_01("Fator_1") = Fator_1_Aux
 Tabela_B_01("Fator_2") = Fator_2_Aux
 Tabela_B_01("Fator_3") = Fator_3_Aux
 Tabela_B_01("Fator_4") = Fator_4_Aux
 Tabela_B_01("NVEL_PLAN") = Nvel_Plan_1_Aux
 Tabela_B_01("Rel_Facilidades") = Rel_Facilidades_Aux
 Tabela_B_01.Update
 Tabela_B_01.Close
 MsgBox "REGISTRO INSERIDO COM SUCESSO NA TABELA-B-01", 48, "Registro Inserido"
End Sub



Sub Altera_Tabela_A_01()

Tabela_A_01.Edit
Tabela_A_01("Desc_Projeto") = Desc_Projeto_Aux
Tabela_A_01("Am_Piloto") = Am_Piloto_Aux
Tabela_A_01("Est_Projeto") = Est_Projeto_Aux
Tabela_A_01("DATA_AVALIAO") = Data_Avaliao_Aux
Tabela_A_01("Num_Alternativas") = Num_Alternativas_Aux
Tabela_A_01("ST_AVALIAO") = Cod_St_Avaliao_Aux
Tabela_A_01("TEC_AVALIAO") = Tec_Avaliao_Aux
Tabela_A_01("Tipo_Projeto") = Tipo_Projeto_Aux
Tabela_A_01("MAP_SITUAO") = Map_Situao_Aux
Tabela_A_01("MAP_LOCALIZAO") = Map_Localizao_Aux
Tabela_A_01.Update
Tabela_A_01.Close
MsgBox "REGISTRO ALTERADO COM SUCESSO NA TABELA-A-01", 48, "Registro Inserido"
End Sub

Sub Consulta_Tabela_A_01_01_Aux()
Abre_Tabela_A_01_01_Aux
Tabela_A_01_01_Aux.Seek "=", Tabela_A_01!EST_PROJETO
 If Tabela_A_01_01_Aux.NoMatch Then
 
    MsgBox "Erro na Tabela Principal", 48, "Campo Invlido"
 Else
 F100001.Est_Projeto_1.Text = Tabela_A_01_01_Aux!NOME_ESTADO
 End If
 Tabela_A_01_01_Aux.Close
End Sub


Sub Consulta_Tabela_A_01_02_Aux()
Abre_Tabela_A_01_02_Aux
Tabela_A_01_02_Aux.Seek "=", Tabela_A_01!TEC_AVALIAO
 If Tabela_A_01_02_Aux.NoMatch Then
 
    MsgBox "erro", 48, "tabela errada"
 Else
 F100001.Tec_Avaliao_1.Text = Tabela_A_01_02_Aux!NOME_TCNICA
 End If
 Tabela_A_01_02_Aux.Close
End Sub



Sub Consulta_Tabela_A_01_03_Aux()
Abre_Tabela_A_01_03_Aux
Tabela_A_01_03_Aux.Seek "=", Tabela_A_01!TIPO_PROJETO
 If Tabela_A_01_03_Aux.NoMatch Then
 
    MsgBox "erro", 48, "tabela errada"
 Else
 F100001.Tipo_Projeto_1.Text = Tabela_A_01_03_Aux!NOME_TIPO
 End If
 Tabela_A_01_03_Aux.Close
End Sub


Sub Consulta_Tabela_A_01_04_Aux()
Abre_Tabela_A_01_04_Aux
Tabela_A_01_04_Aux.Seek "=", Tabela_A_01!ST_AVALIAO
 If Tabela_A_01_04_Aux.NoMatch Then
 
    MsgBox "erro", 48, "tabela errada"
 Else
 F100001.St_Avaliao_1.Text = Tabela_A_01_04_Aux!NOME_ST_AVALIAO
 
 End If
 Tabela_A_01_04_Aux.Close
End Sub




Sub Consulta_Tabela_B_01_01_Aux()
Abre_Tabela_B_01_01_Aux
Tabela_B_01_01_Aux.Seek "=", Nvel_Plan_Aux
 If Tabela_B_01_01_Aux.NoMatch Then
    MsgBox "erro", 48, "tabela errada"
 Else
    'F01_00_002.Nvel_Plan_1.Text = Tabela_B_01_01_Aux!NOME_ABORDAGEM
    Nvel_Plan_1_Aux = Tabela_B_01_01_Aux!NOME_ABORDAGEM
    Debug.Print "nome da abordagem:"; Nvel_Plan_1_Aux
    
 End If
 
 Tabela_B_01_01_Aux.Close
  

 
End Sub


Sub Inclui_Tabela_B_02_01()
 Tabela_B_02_01.AddNew
 Tabela_B_02_01("Cod_Projeto") = Cod_Projeto_Aux
 Tabela_B_02_01("Crit_2111") = Crit_2111_Aux
 Tabela_B_02_01("Crit_2112") = Crit_2112_Aux
 Tabela_B_02_01("Crit_2113") = Crit_2113_Aux
 Tabela_B_02_01("Crit_2114") = Crit_2114_Aux
 Tabela_B_02_01("Crit_2121") = Crit_2121_Aux
 Tabela_B_02_01("Crit_2122") = Crit_2122_Aux
 Tabela_B_02_01("Crit_2131") = Crit_2131_Aux
 Tabela_B_02_01("Crit_2132") = Crit_2132_Aux
 Tabela_B_02_01("Crit_2133") = Crit_2133_Aux
 Tabela_B_02_01.Update
 Tabela_B_02_01.Close
 MsgBox "REGISTRO INSERIDO COM SUCESSO NA TABELA-B-02", 48, "Registro Inserido"
End Sub

Sub Inclui_Tabela_B_02_02()
 Tabela_B_02_02.AddNew
 Tabela_B_02_02("Cod_Projeto") = Cod_Projeto_Aux
 Tabela_B_02_02("Crit_2211") = Crit_2211_Aux
 Tabela_B_02_02("Crit_2212") = Crit_2212_Aux
 Tabela_B_02_02("Crit_2213") = Crit_2213_Aux
 Tabela_B_02_02("Crit_2214") = Crit_2214_Aux
 Tabela_B_02_02("Crit_2215") = Crit_2215_Aux
 Tabela_B_02_02("Crit_2216") = Crit_2216_Aux
 Tabela_B_02_02("Crit_2221") = Crit_2221_Aux
 Tabela_B_02_02("Crit_2222") = Crit_2222_Aux
 Tabela_B_02_02("Crit_2223") = Crit_2223_Aux
 Tabela_B_02_02("Crit_2224") = Crit_2224_Aux
 Tabela_B_02_02("Crit_2225") = Crit_2225_Aux
 Tabela_B_02_02("Crit_2226") = Crit_2226_Aux
 Tabela_B_02_02("Crit_2231") = Crit_2231_Aux
 Tabela_B_02_02("Crit_2232") = Crit_2232_Aux
 Tabela_B_02_02("Crit_2241") = Crit_2241_Aux
 Tabela_B_02_02("Crit_2242") = Crit_2242_Aux
 Tabela_B_02_02("Crit_2243") = Crit_2243_Aux
 Tabela_B_02_02.Update
 Tabela_B_02_02.Close
 MsgBox "REGISTRO INSERIDO COM SUCESSO NA TABELA-B-02", 48, "Registro Inserido"

End Sub

Sub Inclui_Tabela_B_02_03()
 Tabela_B_02_03.AddNew
 Tabela_B_02_03("Cod_Projeto") = Cod_Projeto_Aux
 Tabela_B_02_03("Crit_2311") = Crit_2311_Aux
 Tabela_B_02_03("Crit_2312") = Crit_2312_Aux
 Tabela_B_02_03("Crit_2321") = Crit_2321_Aux
 Tabela_B_02_03("Crit_2322") = Crit_2322_Aux
 Tabela_B_02_03("Crit_2331") = Crit_2331_Aux
 Tabela_B_02_03("Crit_2332") = Crit_2332_Aux
 Tabela_B_02_03("Crit_2333") = Crit_2333_Aux
 Tabela_B_02_03.Update
 Tabela_B_02_03.Close
 MsgBox "REGISTRO INSERIDO COM SUCESSO NA TABELA-B-02", 48, "Registro Inserido"
End Sub



Sub Inclui_Tabela_B_02_04()
 Tabela_B_02_04.AddNew
 Tabela_B_02_04("Cod_Projeto") = Cod_Projeto_Aux
 Tabela_B_02_04("Crit_2411") = Crit_2411_Aux
 Tabela_B_02_04("Crit_2412") = Crit_2412_Aux
 Tabela_B_02_04("Crit_2413") = Crit_2413_Aux
 Tabela_B_02_04("Crit_2421") = Crit_2421_Aux
 Tabela_B_02_04("Crit_2422") = Crit_2422_Aux
 Tabela_B_02_04.Update
 Tabela_B_02_04.Close
 MsgBox "REGISTRO INSERIDO COM SUCESSO NA TABELA-B-02", 48, "Registro Inserido"

 

End Sub


Sub Inclui_Tabela_B_03_01()
 Tabela_B_03_01.AddNew
 Tabela_B_03_01("Cod_Projeto") = Cod_Projeto_Aux
 Tabela_B_03_01("Brancos") = Brancos_Aux
 Tabela_B_03_01("RENDA_MDIA") = Nvel_Renda_Aux
 Tabela_B_03_01.Update
 Tabela_B_03_01.Close
 MsgBox "REGISTRO INSERIDO COM SUCESSO NA TABELA-B-02", 48, "Registro Inserido"
End Sub



Sub Inclui_Tabela_C_01()
 Tabela_C_01.AddNew
 Tabela_C_01("COD_PROJETO") = Cod_Projeto_Aux
 Tabela_C_01("COD_ALTERNATIVA") = Cod_Alternativa_Aux
 Tabela_C_01("IND_EFETIVIDADE") = Efetividade_Aux
 Tabela_C_01("IND_PRIORIDADE") = Prioridade_Aux
 Tabela_C_01.Update
 Contador_Registros = Contador_Registros + 1
 
End Sub

'
Sub Inclui_Tabela_F_01()
 Tabela_F_01.AddNew
 Tabela_F_01("NUM_ALEATRIO") = Num_Aleatrio_Aux
 Tabela_F_01("COD_PROJETO") = Tabela_A_01!Cod_Projeto
 Tabela_F_01("ST_AVAL") = Tabela_A_01!ST_AVALIAO
 Tabela_F_01.Update
 
End Sub



'
'--------------------------------------------------
' Procedimentos de Limpeza de Campos dos
' Formulrios
'--------------------------------------------------
Sub Limpa_Campos_F01_00_001()
  F100001.Cod_Projeto_1.Text = ""
  F100001.Desc_Projeto_1.Text = ""
  F100001.Am_Piloto_1.Value = False
  F100001.Est_Projeto_1.Text = ""
  F100001.Data_Avaliao_1.Text = ""
  F100001.Num_Alternativas_1.Text = ""
  F100001.St_Avaliao_1.Text = ""
  F100001.Tipo_Projeto_1.Text = ""
  F100001.Tec_Avaliao_1.Text = ""
  F100001.Map_Situao_1 = 0
'  F100001.Map_Localizao_1 = 0
  
End Sub


Sub Limpa_Campos_F01_00_002()
  F01_00_002.Cod_Projeto_1.Text = ""
  F01_00_002.Fator_1.Value = False
  F01_00_002.Fator_2.Value = False
  F01_00_002.Fator_3.Value = False
  F01_00_002.Fator_4.Value = False
  F01_00_002.Nvel_Plan_1.Text = ""
  F01_00_002.Rel_Facilidades_1.Text = ""
End Sub


Sub Limpa_Campos_F01_00_003()
  F01_00_003.Cod_Projeto_1.Text = ""
  F01_00_003.Crit_2111_1.Value = False
  F01_00_003.Crit_2112_1.Value = False
  F01_00_003.Crit_2113_1.Value = False
  F01_00_003.Crit_2114_1.Value = False
  F01_00_003.Crit_2121_1.Value = False
  F01_00_003.Crit_2122_1.Value = False
  F01_00_003.Crit_2131_1.Value = False
  F01_00_003.Crit_2132_1.Value = False
  F01_00_003.Crit_2133_1.Value = False
End Sub



Sub Limpa_Campos_F01_00_004()
  F01_00_004.Cod_Projeto_1.Text = ""
  F01_00_004.Crit_2211_1.Value = False
  F01_00_004.Crit_2212_1.Value = False
  F01_00_004.Crit_2213_1.Value = False
  F01_00_004.Crit_2214_1.Value = False
  F01_00_004.Crit_2215_1.Value = False
  F01_00_004.Crit_2215_1.Value = False
  F01_00_004.Crit_2221_1.Value = False
  F01_00_004.Crit_2222_1.Value = False
  F01_00_004.Crit_2223_1.Value = False
  F01_00_004.Crit_2224_1.Value = False
  F01_00_004.Crit_2225_1.Value = False
  F01_00_004.Crit_2226_1.Value = False
  F01_00_004.Crit_2231_1.Value = False
  F01_00_004.Crit_2232_1.Value = False
  F01_00_004.Crit_2241_1.Value = False
  F01_00_004.Crit_2242_1.Value = False
  F01_00_004.Crit_2243_1.Value = False
End Sub



Sub Limpa_Campos_F01_00_005()
  F01_00_005.Cod_Projeto_1.Text = ""
  F01_00_005.Crit_2311_1.Value = False
  F01_00_005.Crit_2312_1.Value = False
  F01_00_005.Crit_2321_1.Value = False
  F01_00_005.Crit_2322_1.Value = False
  F01_00_005.Crit_2331_1.Value = False
  F01_00_005.Crit_2332_1.Value = False
  F01_00_005.Crit_2333_1.Value = False
End Sub


Sub Limpa_Campos_F01_00_006()
  F01_00_006.Cod_Projeto_1.Text = ""
  F01_00_006.Crit_2411_1.Value = False
  F01_00_006.Crit_2412_1.Value = False
  F01_00_006.Crit_2413_1.Value = False
  F01_00_006.Crit_2421_1.Value = False
  F01_00_006.Crit_2422_1.Value = False
End Sub



Sub Limpa_Campos_F01_04_002()
  F01_04_002.Show 1
  
End Sub


Sub Limpa_Campos_F100010()
 F100010.Cod_Projeto_1.Text = ""
 F100010.Cod_Alternativa_1.Text = ""
 F100010.Efetividade_1.Text = ""
 F100010.Prioridade_1.Text = ""
End Sub



Sub Limpa_Campos_F100010_Alternativa()
 F100010.Cod_Alternativa_1.Text = ""
 F100010.Efetividade_1.Text = ""
 F100010.Prioridade_1.Text = ""
End Sub


Sub Verifica_Preenchimento_F()

End Sub

Sub Verifica_Preenchimento_F01_00_001()
  If Num_Alternativas_Aux <> 0 Then
    F100001.Cmd01.Enabled = True
  End If
  
  
  

  
  
End Sub


'--------------------------------------------------
' Procedimentos de Verificao de Tipo de
' Manuteno
'--------------------------------------------------



'--------------------------------------------------
' Procedimentos de Verificao de Preenchimento de
' Formulrios
'--------------------------------------------------

Sub Verifica_St_Grava_Metas()
If Tabela_B_02!STATUS_META_1 = True Then
   St_Meta_1 = True
End If
If Tabela_B_02!sTATUS_META_2 = True Then
   St_Meta_2 = True
End If
If Tabela_B_02!STATUS_META_3 = True Then
   St_Meta_3 = True
End If
If Tabela_B_02!STATUS_META_4 = True Then
   St_Meta_4 = True
End If

If (St_Meta_1 = True And St_Meta_2 = True And St_Meta_3 = True And St_Meta_4 = True) Then
   sT_GRAVA_TODAS = True
   End If
    
End Sub





