Attribute VB_Name = "M000001"
'------------------------------------------------------------------------------'
'                            UNIVERSIDADE DE SO PAULO                          '
'                        ESCOLA DE ENGENHARIA DE SO CARLOS                     '
'                           DEPARTAMENTO DE TRANSPORTES                         '
'                             REA DE PS-GRADUAO                             '
'                                                                               '
'                         PROGRAMA EVALUATOR PARA WINDOWS                       '
'       INTERFACE PARA AVALIAO E ORDENAMENTO DE PROJETOS DE TRANSPORTE        '
'                      COM O USO DAS REDES NEURAIS ARTIFICIAIS                  '
'                                                                               '
'                       VERSO 1.00 - DESENVOLVIDA EM 01/01/98                  '
'                         POR: NILDER FURTADO/EIJI KAWAMOTO                     '
'-------------------------------------------------------------------------------'

'-------------------------------------------------------------------------------'
'                    MDULO 1 -  SERVIO DE BANCO DE DADOS                      '
'                                                                               '
'  Este Mdulo Controla todas as atividades e rotinas do servio de banco de    '
'  dados: incluir/alterar/excluir/consultar/imprimar dados de projetos/alter-   '
'  nativas alm da possibilidade de manuteno das tabelas gerenciadas neste    '
'  programa e da definio de usurios e senhas que podem acessar/alterar  o    '
'  Banco de Dados.  O Banco de Dados foi definido no "Access 97" estando com-   '
'  composto por um conjunto de ENTIDADES/RELACIONAMENTOS, de forma a caracte-   '
'  rizar as variveis de avaliao e deciso relacionadas com um contexto es-   '
'  pecfico. Este esquema pode ser observado na documentao gerada atravs do  '
'  "Access 97" e que faz parte deste pacote.                                    '
'-------------------------------------------------------------------------------'

'-------------------------------------------------------------------------------'
'      01. DEFINIO DAS VARIVEIS GLOBAIS PARA AS FUNES DO BANCO DE DADOS    '
'-------------------------------------------------------------------------------'
Public I%
Public J%
Public K%
Public Nmero_Alternativas
Public Tipo_Alterao As Integer
Public Contador_Alteraes_Form(240)
Public Contador_Campos As Integer
Public Campo_Tabela As Integer
Public Soma As Currency
Public Nmero_Varivel As Integer
Public Nmero_ltima_Varivel As Integer
Public Nmero_Campos As Integer
Public Valor_Entrada As Variant
Public Limite_Min As Currency
Public Limite_Max As Currency
Public Contador_Controle As Integer
Public Contador_Controle_Aux As Integer
Public Contador_Percentual As Integer
Public Form As Form
Public Form_1 As Form
Public Quantidade_Campos
Public Tabela As Recordset
Public Tabela_1 As Recordset
Public Tabela_2 As Recordset
Public Tabela_Aux As String
Public Primeiro_Campo As String
Public Formulrio_Aux As String
Public Formulrio As Integer
Public Alteraes As Integer
Public St_Vrias_Alteraes As Boolean
Public Cod_Projeto_Operao As Integer
Public Contador_Alterao As Integer
Public Seleo_Consulta(1 To 7)
Public Tipo_Consulta As Integer
Public St_Achou_Registro As Boolean

Public Contador_Linhas As Integer



Public Nmero_Varivel_Secundria
 


Public Tipo_Padro As Integer

Public Cod_St_Avaliao_Aux As Integer
Public Tipo_Manuteno As Integer


'' Public Type Registro_Aleatrio
 ''  Aleatrio As VARIANT
 ''  Cod_Projeto As Integer
 ''  Avaliao As Integer
'' End Type
'' Dim Registro_1 As Registro_Aleatrio
 
 Private Type Registro_Particionado
 Tipo_Partio As String * 3
  Cod_Projeto As Integer
  Aleatrio As Variant
   
  Avaliao As Integer
End Type
 ''Dim Registro_2 As Registro_Particionado


Public Num_Aleatrio_Aux As Long
Public St_Grava_Registro_Tabela_A_01 As Boolean
Public St_Grava_Registro_Tabela_B_01 As Boolean
Public St_Alterao_Todos_1 As Boolean
Public St_Alterao_Desc_Projeto As Boolean
Public St_Alterao_Am_Piloto As Boolean
Public St_Alterao_Est_Projeto As Boolean
Public St_Alterao_Data_Avaliao As Boolean
Public St_Alterao_Num_Alternativas As Boolean
Public St_Alterao_St_Avaliao As Boolean
Public St_Alterao_Tec_Avaliao As Boolean
Public St_Alterao_Tipo_Projeto As Boolean
Public St_Alterao_Map_Situao As Boolean
Public St_Alterao_Map_Localizao As Boolean
Public St_Meta_1 As Boolean
Public St_Meta_2 As Boolean
Public St_Meta_3 As Boolean
Public St_Meta_4 As Boolean
Public sT_GRAVA_TODAS As Boolean
Public St_Altera_Estado As Boolean
Public St_Altera_Status As Boolean
Public St_Altera_Tcnica As Boolean
Public St_Altera_Tipo As Boolean
Public St_Altera_Nvel As Boolean













Public BD As Database
Public BD1 As Database
Public BD_Aux As Database
Public Tabela_A_01 As Recordset
Public Tabela_A1_01 As Recordset
Public Tabela_A_01_01 As Recordset
Public Tabela_A_01_01_Aux As Recordset
Public Tabela_A_01_02 As Recordset
Public Tabela_A_01_02_Aux As Recordset
Public Tabela_A_01_03 As Recordset
Public Tabela_A1_01_03 As Recordset
Public Tabela_A_01_03_Aux As Recordset
Public Tabela_A_01_04 As Recordset
Public Tabela_A_01_04_Aux As Recordset
Public Tabela_B_01 As Recordset
Public Tabela_B1_01 As Recordset
Public Tabela_B_01_01 As Recordset
Public Tabela_B1_01_01 As Recordset
Public Tabela_B_01_01_Aux As Recordset
Public Tabela_B_02_01 As Recordset
Public Tabela_B1_02_01 As Recordset
Public Tabela_B_02_02 As Recordset
Public Tabela_B1_02_02 As Recordset
Public Tabela_B_02_03 As Recordset
Public Tabela_B1_02_03 As Recordset
Public Tabela_B_02_04 As Recordset
Public Tabela_B1_02_04 As Recordset
Public Tabela_B_03_01 As Recordset
Public Tabela_B1_03_01 As Recordset
Public Tabela_B_03_02 As Recordset
Public Tabela_B1_03_02 As Recordset
Public Tabela_B_04 As Recordset
Public Tabela_B1_04 As Recordset
Public Tabela_C_01 As Recordset
Public Tabela_C_01_Aux As Recordset
Public Tabela_C_02 As Recordset
Public Tabela_C_02_Aux As Recordset
Public Tabela_C_02_01 As Recordset
Public Tabela_C_02_01_Aux As Recordset
Public Tabela_C_03 As Recordset
Public Tabela_C_03_Aux As Recordset
Public Tabela_C_04 As Recordset
Public Tabela_C_04_Aux As Recordset
Public Tabela_C_05_01 As Recordset
Public Tabela_C_05_02 As Recordset
Public Tabela_C_05_03 As Recordset
Public Tabela_C_06 As Recordset
Public Tabela_C_07 As Recordset
Public Tabela_C_08 As Recordset
Public Tabela_C_09 As Recordset
Public Tabela_C_09_01 As Recordset
Public Tabela_C_10 As Recordset
Public Tabela_C_11 As Recordset
Public Tabela_C_12 As Recordset
Public Tabela_C_13 As Recordset
Public Tabela_D_01 As Recordset
Public Consulta_Projetos As QueryDef
Public Consulta_Projeto As Recordset
Public Consulta_Alternativas As QueryDef
Public Consulta_Alternativa As Recordset
Public Tabela_F_01 As Recordset
Public Tabela_G_01 As Recordset
Public Tabela_X_01 As Recordset
Public Tabela_Y_01 As Recordset






Public Tipo_Operao As Integer

Public Tipo_Servio As Integer



Public Num_Alternativas_Aux As Integer

Public Est_Projeto_1_Aux As String
Public St_Avaliao_1_Aux As String
Public Tec_Avaliao_1_Aux As String
Public Tipo_Projeto_1_Aux As String
Public Nvel_Plan_1_Aux As String
Public Varivel_Auxiliar_1(12, 10)
Public Varivel_Auxiliar(12, 10) 'armazena dados das tabelas auxiliares

'tabela-a-01
Public Cod_Projeto_Aux As Integer
Public Projeto_A_01(1, 10)
Public Alternativas_1_Aux(12, 2)
Public Efetividade_Aux As Currency
Public Prioridade_Aux As Integer
'tabela_c_02
Public Vetor_Projeto(999, 23, 25)
Public Vetor_Alternativas(12, 23, 25)
Public Vetor_Alternativas_Aux(1, 12, 23, 25)
Public Tipo_Gerao_Partio As Integer
Public Treinamento As Boolean
Public Validao As Boolean
Public Teste As Boolean
Public Treinamento_Aux As Boolean
Public Validao_Aux As Boolean
Public Teste_Aux As Boolean



       
Public Cod_Alternativa_Aux As Integer





'--------------------------------------------------
' VARIVEIS DE CONTAGEM PERCENTUAL PARA CONSULTAS
'--------------------------------------------------


Public Contador_Registros As Integer
Public Contador_Alteraes(23, 1)
Public Contador_Alteraes_Aux(23, 1)



Public Tipo_Consulta_Percentual As Integer
Public Indicador_Tipo_Projeto(16, 1)
Public Tipo_Projeto(16, 1)
Public Indicador_Tipo_Tcnica(8, 1)
Public Tec_Tipo(8, 1)
Public Indicador_Status(3, 1)
Public Status(3, 1)
Public Indicador_Nmero_Alt(3, 1)
Public Num_Alternativas(3, 1)
Public Indicador_Data(4, 1)
Public Data(4, 1)









 
   
'-------------------------------------------------------
'PARTE B
'ABERTURA DAS TABELAS DO BANCO DE DADOS (ACCESS)
'-------------------------------------------------------




Sub Abre_Consulta_Alternativa()
'' Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Consulta_Alternativas = BD.QueryDefs![CONSULTA-1-02]
 Set Consulta_Alternativa = Consulta_Alternativas.OpenRecordset(dbOpenSnapshot)
End Sub

Sub Abre_Consulta_Projeto()
'' Set BD = DBEngine.Workspaces(0).OpenDatabase("C:/EVALUATOR/BDEVAL.MDB")
 Set Consulta_Projetos = BD.QueryDefs("CONSULTA-1-01")
 Set Consulta_Projeto = Consulta_Projetos.OpenRecordset(dbOpenSnapshot)
End Sub


Sub Abre_Tabela()
  Select Case Formulrio
   Case 1
    Set Tabela_A_01 = BD.OpenRecordset("Tabela-A-01", dbOpenTable)
    Tabela_A_01.Index = "PrimaryKey"
    Set Tabela = Tabela_A_01
   Case 2
    Set Tabela_B_01 = BD.OpenRecordset("Tabela-B-01", dbOpenTable)
    Tabela_B_01.Index = "PrimaryKey"
    Set Tabela = Tabela_B_01
   Case 3
    Set Tabela_B_02_01 = BD.OpenRecordset("Tabela-B-02-01", dbOpenTable)
    Tabela_B_02_01.Index = "PrimaryKey"
    Set Tabela = Tabela_B_02_01
   Case 4
    Set Tabela_B_02_02 = BD.OpenRecordset("Tabela-B-02-02", dbOpenTable)
    Tabela_B_02_02.Index = "PrimaryKey"
    Set Tabela = Tabela_B_02_02
   Case 5
    Set Tabela_B_02_03 = BD.OpenRecordset("Tabela-B-02-03", dbOpenTable)
    Tabela_B_02_03.Index = "PrimaryKey"
    Set Tabela = Tabela_B_02_03
   Case 6
    Set Tabela_B_02_04 = BD.OpenRecordset("Tabela-B-02-04", dbOpenTable)
    Tabela_B_02_04.Index = "PrimaryKey"
    Set Tabela = Tabela_B_02_04
   Case 7
    Set Tabela_B_03_01 = BD.OpenRecordset("Tabela-B-03-01", dbOpenTable)
    Tabela_B_03_01.Index = "PrimaryKey"
    Set Tabela = Tabela_B_03_01
   Case 8
    Set Tabela_B_03_02 = BD.OpenRecordset("Tabela-B-03-02", dbOpenTable)
    Tabela_B_03_02.Index = "PrimaryKey"
    Set Tabela = Tabela_B_03_02
   Case 9
    Set Tabela_B_04 = BD.OpenRecordset("Tabela-B-04", dbOpenTable)
    Tabela_B_04.Index = "PrimaryKey"
    Set Tabela = Tabela_B_04
   Case 10
    Set Tabela_C_01 = BD.OpenRecordset("Tabela-C-01", dbOpenTable)
    Tabela_C_01.Index = "PrimaryKey"
    Set Tabela = Tabela_C_01
   Case 11
     Set Tabela_C_02 = BD.OpenRecordset("Tabela-C-02", dbOpenTable)
     Tabela_C_02.Index = "PrimaryKey"
     Set Tabela = Tabela_C_02
    Case 12
     Set Tabela_C_03 = BD.OpenRecordset("Tabela-C-03", dbOpenTable)
     Tabela_C_03.Index = "PrimaryKey"
     Set Tabela = Tabela_C_03
    Case 13
     Set Tabela_C_04 = BD.OpenRecordset("Tabela-C-04", dbOpenTable)
     Tabela_C_04.Index = "PrimaryKey"
     Set Tabela = Tabela_C_04
    Case 14
     Set Tabela_C_05_02 = BD.OpenRecordset("Tabela-C-05-02", dbOpenTable)
     Tabela_C_05_02.Index = "PrimaryKey"
     Set Tabela = Tabela_C_05_02
    Case 15
     Set Tabela_C_05_03 = BD.OpenRecordset("Tabela-C-05-03", dbOpenTable)
     Tabela_C_05_03.Index = "PrimaryKey"
     Set Tabela = Tabela_C_05_03
    Case 16
     Set Tabela_C_06 = BD.OpenRecordset("Tabela-C-06", dbOpenTable)
     Tabela_C_06.Index = "PrimaryKey"
     Set Tabela = Tabela_C_06
    Case 17
     Set Tabela_C_07 = BD.OpenRecordset("Tabela-C-07", dbOpenTable)
     Tabela_C_07.Index = "PrimaryKey"
     Set Tabela = Tabela_C_07
    Case 18
     Set Tabela_C_08 = BD.OpenRecordset("Tabela-C-08", dbOpenTable)
     Tabela_C_08.Index = "PrimaryKey"
     Set Tabela = Tabela_C_08
      Case 19
     Set Tabela_C_09 = BD.OpenRecordset("Tabela-C-09", dbOpenTable)
     Tabela_C_09.Index = "PrimaryKey"
     Set Tabela = Tabela_C_09
    Case 20
     Set Tabela_C_10 = BD.OpenRecordset("Tabela-C-10", dbOpenTable)
     Tabela_C_10.Index = "PrimaryKey"
     Set Tabela = Tabela_C_10
    Case 21
     Set Tabela_C_11 = BD.OpenRecordset("Tabela-C-11", dbOpenTable)
     Tabela_C_11.Index = "PrimaryKey"
     Set Tabela = Tabela_C_11
    Case 22
     Set Tabela_C_12 = BD.OpenRecordset("Tabela-C-12", dbOpenTable)
     Tabela_C_12.Index = "PrimaryKey"
     Set Tabela = Tabela_C_12
    Case 23
     Set Tabela_C_13 = BD.OpenRecordset("Tabela-C-13", dbOpenTable)
     Tabela_C_13.Index = "PrimaryKey"
     Set Tabela = Tabela_C_13
  End Select
End Sub


Sub Abre_Tabela_1()
 Select Case Formulrio
  Case 1
   Set Tabela_A_01_01 = BD.OpenRecordset("Tabela-A-01-01", dbOpenTable)
   Tabela_A_01_01.Index = "Nome_do_Estado"
   Set Tabela_A_01_02 = BD.OpenRecordset("Tabela-A-01-02", dbOpenTable)
   Tabela_A_01_02.Index = "Nome_Tcnica"
   Set Tabela_A_01_03 = BD.OpenRecordset("Tabela-A-01-03", dbOpenTable)
   Tabela_A_01_03.Index = "Nome_Tipo"
   Set Tabela_A_01_04 = BD.OpenRecordset("Tabela-A-01-04", dbOpenTable)
   Tabela_A_01_04.Index = "Nome_St_Avaliao"
  Case 2
   Set Tabela_B_01_01 = BD.OpenRecordset("Tabela-B-01-01", dbOpenTable)
   Tabela_B_01_01.Index = "Nome_Abordagem"
   Set Tabela_1 = Tabela_B_01_01
  Case 11
   Set Tabela_C_02_01 = BD.OpenRecordset("Tabela-C-02-01", dbOpenTable)
   Tabela_C_02_01.Index = "Nome_Nvel"
   Set Tabela_1 = Tabela_C_02_01
  Case 14
   Set Tabela_C_05_01 = BD.OpenRecordset("Tabela-C-05-01", dbOpenTable)
   Tabela_C_05_01.Index = "Nome_Recurso"
   Set Tabela_1 = Tabela_C_05_01
  Case 19
   Set Tabela_C_09_01 = BD.OpenRecordset("Tabela-C-09-01", dbOpenTable)
   Tabela_C_09_01.Index = "Nome_Sensibilidade"
   Set Tabela_1 = Tabela_C_09_01
  End Select
End Sub


Sub Abre_Tabela_2()
Select Case Formulrio
  Case 1
   Set Tabela_A_01_01_Aux = BD.OpenRecordset("Tabela-A-01-01", dbOpenTable)
   Tabela_A_01_01_Aux.Index = "PrimaryKey"
   Set Tabela_A_01_02_Aux = BD.OpenRecordset("Tabela-A-01-02", dbOpenTable)
   Tabela_A_01_02_Aux.Index = "PrimaryKey"
   Set Tabela_A_01_03_Aux = BD.OpenRecordset("Tabela-A-01-03", dbOpenTable)
   Tabela_A_01_03_Aux.Index = "PrimaryKey"
   Set Tabela_A_01_04_Aux = BD.OpenRecordset("Tabela-A-01-04", dbOpenTable)
   Tabela_A_01_04_Aux.Index = "PrimaryKey"
  Case 2
   Set Tabela_B_01_01_Aux = BD.OpenRecordset("Tabela-B-01-01", dbOpenTable)
   Tabela_B_01_01_Aux.Index = "PrimaryKey"
   Set Tabela_2 = Tabela_B_01_01_Aux
  Case 10
   Set Tabela_C_01_Aux = BD.OpenRecordset("Tabela-C-01", dbOpenTable)
   Tabela_C_01_Aux.Index = "Cod_Projeto"
  Case 11
   Set Tabela_C_02_01_Aux = BD.OpenRecordset("Tabela-C-02-01", dbOpenTable)
   Tabela_C_02_01_Aux.Index = "PrimaryKey"
   Set Tabela_2 = Tabela_C_02_01_Aux
  Case 14
   Set Tabela_C_05_01_Aux = BD.OpenRecordset("Tabela-C-05-01", dbOpenTable)
   Tabela_C_05_01_Aux.Index = "PrimaryKey"
   Set Tabela_2 = Tabela_C_05_01_Aux
  Case 19
   Set Tabela_C_09_01_Aux = BD.OpenRecordset("Tabela-C-09-01", dbOpenTable)
   Tabela_C_09_01_Aux.Index = "PrimaryKey"
   Set Tabela_2 = Tabela_C_09_01_Aux
  End Select
End Sub















































































Sub Abre_Tabela_A_01()
 Set Tabela_A_01 = BD.OpenRecordset("Tabela-A-01", dbOpenTable)
 Tabela_A_01.Index = "PrimaryKey"
 Set Tabela = Tabela_A_01
End Sub

Sub Abre_Tabela_D_01()
 Set Tabela_D_01 = BD.OpenRecordset("Tabela-D-01", dbOpenTable)
 Tabela_D_01.Index = "PrimaryKey"
End Sub



Sub Abre_Tabela_F_01()
 Set Tabela_F_01 = BD.OpenRecordset("Tabela-F-01", dbOpenTable)
 Tabela_F_01.Index = "PrimaryKey"
End Sub



Sub Abre_Tabela_G_01()
 Set Tabela_G_01 = BD.OpenRecordset("Tabela-G-01", dbOpenTable)
 Tabela_G_01.Index = "PrimaryKey"
End Sub

Sub Abre_Tabela_X_01()
 Set Tabela_X_01 = BD.OpenRecordset("Tabela-X-01", dbOpenTable)
 Tabela_X_01.Index = "PrimaryKey"
End Sub

Sub Cancela_Operao()
If Tipo_Operao = 0 Or Tipo_Operao = 3 Then
    If Contador_Alteraes(Alteraes, 1) = 0 Then
       If Cod_Projeto_1 = "" Or Cod_Projeto_Aux > 0 Then
          Mensagem_1 (11)
          Tipo_Operao = 0
         ' Unload Name.Formulrio
          Tipo_Operao = 3
          Unload F102001
       Else
           Mensagem_1 (8)
           Tipo_Operao = 0
           Unload Name.Formulrio
           Tipo_Operao = 3
       End If
    Else
       If Contador_Alteraes(Alteraes, 1) <> Contador_Alteraes_Aux(Alteraes, 1) Then
          Mensagem_1 (9)
          Cmd01.Enabled = True
       End If
    End If
    End If
End Sub



















Sub Chama_Cmd01()
 Select Case Tipo_Operao
  Case 0
   Tipo_Operao = 3
  Case 1, 9
   Unload Form
   If Formulrio <> 23 Then
      If Formulrio = 9 Then
         Mensagem_1 (25)
      End If
      Form_1.Show 1
   Else
      If Contador_Alternativas < Num_Alternativas_Aux Then
         Contador_Alternativas = Contador_Alternativas + 1
         If Tipo_Operao = 1 Then
         Set Form = F100010
         Else
          Set Form = F100011
         End If
         Form.Controls(1) = Contador_Alternativas
         Form.Show
      Else
         Inclui_Tabela_Projeto_Alternativas
      End If
   End If
  Case 2
   Select Case Formulrio
    Case 1 To 9
     Inclui_Tabela_Projeto
     If Contador_Alternativas <= Num_Alternativas_Aux Then
        Mensagem_1 (12)
        If Resposta = 6 Then
           Limpa_Campos
           Contador_Controle = 1
           Form.Controls(0) = ""
           Form.Controls(0).Enabled = True
           Form.Controls(0).SetFocus
           Form.Cmd01.Enabled = False
        Else
           Unload Form
        End If
     Else
        Mensagem_1 (20)
        Unload Form
     End If
    Case 10 To 23
     Inclui_Tabela_Alternativa
     If Cod_Alternativa_Aux < Num_Alternativas_Aux Then
        Mensagem_1 (23)
        If Resposta = 6 Then
           Limpa_Campos
           Contador_Controle = 2
           Form.Cod_Alternativa_1.Enabled = True
           Form.Cod_Alternativa_1.SetFocus
           Form.Cmd01.Enabled = False
        Else
           Mensagem_1 (24)
           If Resposta = 6 Then
              Limpa_Campos
              Contador_Controle = 2
              Contador_Alternativas = 1
              Form.Controls(0) = ""
              Form.Controls(0).Enabled = True
              Form.Controls(0).SetFocus
              Form.Cmd01.Enabled = False
           Else
              Unload Form
           End If
        End If
     Else
        Mensagem_1 (20)
        Mensagem_1 (24)
        If Resposta = 6 Then
           Limpa_Campos
           Contador_Controle = 2
           Contador_Alternativas = 1
           Form.Controls(0) = ""
           Form.Controls(0).Enabled = True
           Form.Controls(0).SetFocus
           Form.Cmd01.Enabled = False
        Else
           Unload Form
        End If
     End If
     Contador_Alternativas = 1
   End Select
  Case 3
   Abre_Tabela
   If Formulrio < 10 Then
   Inclui_Tabela_Projeto
   Else
   Inclui_Tabela_Alternativa
   End If
   Contador_Alteraes(Alteraes, 1) = 0
   Contador_Alteraes_Aux(Alteraes, 1) = 0
   Tipo_Operao = 0
   Mensagem_1 (15)
   Tipo_Operao = 3
   Mensagem_1 (13)
   If Resposta = 6 Then
      Unload Form
      Unload F102001
      F102001.Show 1
   Else
      Unload Form
   End If
  Case 7
   Unload Form
   If Formulrio < 9 Then
    Formulrio = Formulrio + 1
    If Formulrio = 2 Then
       Set Form = F100002
    Else
    Set Form = Form_1
    End If
    
    Preenche_Formulrio
    Form.Show 1
   Else
      If Nmero_Alternativas <= Num_Alternativas_Aux Then
         If Formulrio < 23 Then
            Formulrio = Formulrio + 1
            Cod_Alternativa_Aux = Nmero_Alternativas
            Set Form = Form_1
            Form.Controls(1) = Cod_Alternativa_Aux
            Preenche_Formulrio
            Form.Show 1
          Else
            Nmero_Alternativas = Nmero_Alternativas + 1
            If Nmero_Alternativas <= Num_Alternativas_Aux Then
               Formulrio = 10
               Set Form = F100010
               Form.Controls(1) = Cod_Alternativa_Aux
               Cod_Alternativa_Aux = Nmero_Alternativas
               Preenche_Formulrio
               Form.Show 1
             Else
               Unload Form
               Mensagem_1 (31)
             End If
         End If
       Else
         Unload Form
       End If
   End If
  Case 10
   Unload Form
   If Formulrio < 23 Then
      Formulrio = Formulrio + 1
      Set Form = Form_1
      Preenche_Formulrio
      Form.Show 1
   Else
      Mensagem_1 (32)
      Unload Form
   End If
 End Select
End Sub

Sub Chama_Cmd02()
If Tipo_Operao = 0 Or Tipo_Operao = 3 Then
    If Contador_Alteraes(Alteraes, 1) = 0 Then
       If Cod_Projeto_1 = "" Or Cod_Projeto_Aux > 0 Then
          Mensagem_1 (11)
          Tipo_Operao = 0
          ''Descarrega_Formulrio
          Tipo_Operao = 3
          Unload F102001
       Else
           Mensagem_1 (8)
           Tipo_Operao = 0
           ''Descarrega_Formulrio
           Tipo_Operao = 3
       End If
    Else
       If Contador_Alteraes(Alteraes, 1) <> Contador_Alteraes_Aux(Alteraes, 1) Then
          Mensagem_1 (9)
          ''Habilita_Cmd01
       End If
    End If
    End If
End Sub



Sub Consulta_Tabela_Auxiliar()
 Select Case Formulrio
  Case 1
   Formulrio = 1
   Abre_Tabela_2
   Tabela_A_01_01_Aux.Seek "=", Tabela_A_01!EST_PROJETO
   If Tabela_A_01_01_Aux.NoMatch Then
      Mensagem_1 (4)
      End
   Else
      F100001.Est_Projeto_1.Text = Tabela_A_01_01_Aux!NOME_ESTADO
   End If
   Tabela_A_01_02_Aux.Seek "=", Tabela_A_01!TEC_AVALIAO
   If Tabela_A_01_02_Aux.NoMatch Then
      Mensagem_1 (4)
      End
   Else
      F100001.Tec_Avaliao_1.Text = Tabela_A_01_02_Aux!NOME_TCNICA
   End If
   Tabela_A_01_03_Aux.Seek "=", Tabela_A_01!Tipo_Projeto
   If Tabela_A_01_03_Aux.NoMatch Then
      Mensagem_1 (4)
      End
   Else
      F100001.Tipo_Projeto_1.Text = Tabela_A_01_03_Aux!NOME_TIPO
   End If
   Tabela_A_01_04_Aux.Seek "=", Tabela_A_01!ST_AVALIAO
   If Tabela_A_01_04_Aux.NoMatch Then
      Mensagem_1 (4)
      End
   Else
      F100001.St_Avaliao_1 = Tabela_A_01_04_Aux!NOME_ST_AVALIAO
   End If
   Tabela_A_01_01_Aux.Close
   Tabela_A_01_02_Aux.Close
   Tabela_A_01_03_Aux.Close
   Tabela_A_01_04_Aux.Close
  Case 2
    Formulrio = 2
    Abre_Tabela_2
    Tabela_2.Seek "=", Tabela!NVEL_PLAN
    If Tabela_2.NoMatch Then
       Mensagem_1 (4)
       Stop
       End
    Else
       F100002.Nvel_Plan_1 = Tabela_2!NOME_ABORDAGEM
    End If
    Tabela_2.Close
  Case 11
    Formulrio = 11
    Abre_Tabela_2
    
    Tabela_2.Seek "=", Tabela!NVEL_SERVIO_PICO
    If Tabela_2.NoMatch Then
       Mensagem_1 (4)
       End
    Else
       F100011.Nvel_Servio_Pico_1 = Tabela_2!NOME_NVEL_SERVIO
    End If
    Tabela_2.Close
  Case 14
    Formulrio = 14
    Abre_Tabela_2
    Tabela_2.Seek "=", Tabela!REC_SUBSOLO
    If Tabela_2.NoMatch Then
       Mensagem_1 (4)
       End
    Else
       F100014.Rec_Subsolo_1 = Tabela_2!NOME_RECURSO_SUBSOLO
    End If
    Tabela_2.Close
  Case 19
    Formulrio = 19
    Abre_Tabela_2
    Tabela_2.Seek "=", Tabela!IMP_VIBRAES_ACEL
    If Tabela_2.NoMatch Then
       Mensagem_1 (4)
       End
    Else
       F100019.Imp_Vibraes_Acel_1 = Tabela_2!NOME_SENSIBILIDADE
    End If
    Tabela_2.Close
  End Select
End Sub

Sub Consulta_Visibilidade_Coluna()
'' Case Tipo_Consulta 111
 ''Consulta_00_Ord.Columns(0).Visible = False
'' Consulta_00_Ord.Columns(1).Visible = False
'' Consulta_00_Ord.Columns(2).Visible = False
'' Consulta_00_Ord.Columns(3).Visible = False
'' Consulta_00_Ord.Columns(4).Visible = False
'' Consulta_00_Ord.Columns(5).Visible = False
End Sub




























Sub Conta_Alternativas()
 Do Until Tabela.EOF
      If Cod_Projeto_Aux = Tabela!Cod_Projeto Then
         Contador_Alternativas = Contador_Alternativas + 1
      Else
         Exit Do
      End If
      Tabela.MoveNext
   Loop
End Sub






Sub Deleta_Registro_Alternativa()
 Formulrio = 10
 Do Until Formulrio > 23
    Abre_Tabela
    Tabela.Seek "=", Cod_Projeto_Aux, Cod_Alternativa_Aux
    If Tabela.NoMatch Then
    Else
       Tabela.Delete
       Tabela.MoveNext
       Tabela.Close
    End If
    Formulrio = Formulrio + 1
 Loop
 Mensagem_1 (29)
 Formulrio = 0
End Sub

Sub Deleta_Registro_Completo()
 Formulrio = 1
 Do Until Formulrio > 9
    Abre_Tabela
    Tabela.Seek "=", Cod_Projeto_Aux
    If Tabela.NoMatch Then
    Else
       Tabela.Delete
       Tabela.Close
    End If
    Formulrio = Formulrio + 1
 Loop
 Cod_Alternativa_Aux = 1
 Do Until Formulrio > 23
    Abre_Tabela
    Tabela.Seek "=", Cod_Projeto_Aux, Cod_Alternativa_Aux
    If Tabela.NoMatch Then
    Else
       Do Until Cod_Projeto_Aux <> Tabela!Cod_Projeto
          Tabela.Delete
          Tabela.MoveNext
       Loop
    End If
    Tabela.Close
    Formulrio = Formulrio + 1
 Loop
 Mensagem_1 (28)
 Formulrio = 0
End Sub


Sub Grava_Cabealho_Arquivo_Impresso()
 Print #1, ""
 Print #1, ""
 Print #1, String(80, "-")
 Print #1, "     EVALUATOR"
 Print #1, "     ARQUIVO DE IMPRESSO DE REGISTROS DO BANCO DE DADOS"
 Print #1, "     Desenvolvido por: Nilder Furtado/Eiji Kawamoto"
 Print #1, "     Data/Horario da Solicitao/Impresso:"; Date; Time
 Print #1, ""
 Select Case Tipo_Operao
  Case 8
   Print #1, Tab(5); "Impresso do Banco de Dados Completo"
  Case 81
   Print #1, Tab(5); "Impresso de Dados de Projeto/Alternativas"
  Case 82
   Print #1, Tab(5); "Impresso de Dados de Projeto"
  Case 83
   Print #1, Tab(5); "Impresso de Dados de Alternativa"
 End Select
 Print #1, String(80, "-")
 Print #1, ""
 Print #1, ""
End Sub

Sub Grava_Cabealho_Impresso_Tabela()
 Print #1, String(80, "-")
 Select Case Formulrio
  Case 2
   Print #1, Tab(7); "DADOS DA TABELA B-01-PROPSITOS E NECESSIDADES"
  Case 3
   Print #1, Tab(7); "DADOS DA TABELA B-02-META 1: PROPORCIONAR SERVIOS DE TRANSPORTE DE ALTA QUALIDADE"
  Case 4
   Print #1, Tab(7); "DADOS DA TABELA B-02-META 2: MANTER OS VALORES SOCIAIS, NATURIAS E CULTURAIS DA REGIO AFETADA"
  Case 5
   Print #1, Tab(7); "DADOS DA TABELA B-02-META 3: MANTER O CRESCIMENTO PLANEJADO E A VITALIDADE ECONMICA"
  Case 6
   Print #1, Tab(7); "DADOS DA TABELA B-02-META 4: OTIMIZAR O INVESTIMENTO"
  Case 7
   Print #1, Tab(7); "DADOS DA TABELA B-03-PERFIL SOCIAL DA REA DE ESTUDO"
  Case 8
   Print #1, Tab(7); "DADOS DA TABELA B-03-PERFIL ECONMICO DA REA DE ESTUDO"
  Case 9
   Print #1, Tab(7); "DADOS DA TABELA B-04-CONTEXTO POLTICO E INSTIUCIONAL"
  Case 10
   Print #1, Tab(7); "DADOS DA TABELA C-01-NDICES DE DESEMPENHO"
  Case 11
   Print #1, Tab(7); "DADOS DA TABELA C-02-PREVISO DE TRFEGO E DEMANDA"
  Case 12
   Print #1, Tab(7); "DADOS DA TABELA C-03-IMPACTOS SOCIAIS E ECONMICOS"
  Case 13
   Print #1, Tab(7); "DADOS DA TABELA C-04-IMPACTOS SOBRE RECURSOS CULTURAIS"
  Case 14
   Print #1, Tab(7); "DADOS DA TABELA C-05-IMPACTOS SOBRE O MEIO AMBIENTE"
  Case 15
   Print #1, Tab(7); "DADOS DA TABELA C-05-IMPACTOS SOBRE OS ECOSSISTEMAS"
  Case 16
   Print #1, Tab(7); "DADOS DA TABELA C-06-IMPACTOS SOBRE A QUALIDADE DO AR"
  Case 17
   Print #1, Tab(7); "DADOS DA TABELA C-07-IMPACTOS PROVOCADOS PELOS NVEIS DE RUDO"
  Case 18
   Print #1, Tab(7); "DADOS DA TABELA C-08-IMPACTOS NO MANEJO DE MATERIAIS PERIGOSOS"
  Case 19
   Print #1, Tab(7); "DADOS DA TABELA C-09-IMPACTOS NA QUALIDADE VISUAL"
  Case 20
   Print #1, Tab(7); "DADOS DA TABELA C-10-IMPACTOS NO PLANEJAMENTO DE CURTO E LONGO PRAZOS"
  Case 21
   Print #1, Tab(7); "DADOS DA TABELA C-11-COMPROMETIMENTO DE RECURSOS RENOVVEIS E IRRENOVVEIS"
  Case 22
   Print #1, Tab(7); "DADOS DA TABELA C-12-CUSTOS E BENEFCIOS MONETRIOS"
  Case 23
   Print #1, Tab(7); "DADOS DA TABELA C-13-SEO 4(F)-RECURSOS CULTURAIS E NATURAIS"
 End Select
 Print #1, String(80, "-")
End Sub

Sub Grava_Registro_Impresso_Alternativa()
 For I% = 1 To Nmero_Campos
     Abre_Tabela_D_01
     Tabela_D_01.Seek "=", Nmero_Varivel
     If I% = 1 Then
        Print #1, Tab(10); "Dados do Projeto: "; Tabela.Fields(0)
        Print #1, Tab(10); "Dados da Alternativa: "; Tabela.Fields(1)
     End If
        Print #1, Tab(15); "Varivel ==> " & Tabela_D_01!NOME_VAR
        Select Case VarType(Tabela.Fields(I% + 1))
         Case 0, 1
          Print #1, Tab(15); "Valor No Inicializado na Tabela"
         Case 2, 6
          If Tabela.Fields(I% + 1) = -32768 Then
             Print #1, Tab(15); "Valor ==> " & "?"
          Else
             Print #1, Tab(15); "Valor ==> "; Tabela.Fields(I% + 1)
          End If
         Case 8
          Print #1, Tab(15); "Valor ==> "; Tabela.Fields(I% + 1)
         Case 11
          If Tabela.Fields(I% + 1) = True Then
             Print #1, Tab(15); "Valor ==> " & "Presente"
          Else
             Print #1, Tab(15); "Valor==> " & "No Considerado"
          End If
         End Select
         Nmero_Varivel = Nmero_Varivel + 1
     Tabela_D_01.Close
 Next
End Sub

Sub Grava_Registro_Impresso_Projeto()
 Nmero_Varivel = Nmero_Varivel_Secundria + 1
 For I% = 0 To Nmero_Campos
     Abre_Tabela_D_01
     Tabela_D_01.Seek "=", Nmero_Varivel
     If I% = 0 Then
        Print #1, Tab(10); "Dados do Projeto: "; Tabela.Fields(0)
     Else
        Print #1, Tab(15); "Varivel ===> " & Tabela_D_01!NOME_VAR
        Select Case VarType(Tabela.Fields(I%))
        Case 0, 1
         Print #1, Tab(15); " Valor No Inicializado na Tabela"
        Case 2, 6
         If Tabela.Fields(I%) = -32768 Then
            Print #1, Tab(15); "Valor ===> " & "?"
         Else
            Print #1, Tab(15); "Valor ===> "; Tabela.Fields(I%)
         End If
        Case 8
         Print #1, Tab(15); "Valor ===> "; Tabela.Fields(I%)
        Case 11
         If Tabela.Fields(I%) = True Then
            Print #1, Tab(15); "Valor ===> " & "Presente"
         Else
            Print #1, Tab(15); "Valor ===> " & "No Considerado"
         End If
       End Select
       Nmero_Varivel = Nmero_Varivel + 1
    End If
    Tabela_D_01.Close
 Next
 Tabela.MoveNext
End Sub


Sub Imprime_Dados_Alternativas()
 On Error Resume Next
 Dim Contador_Campos
 Contador_Campos = Array(2, 23, 22, 4, 16, 20, 6, 5, 4, 5, 10, 4, 8, 6)
 Do Until Formulrio > 23
    Nmero_Campos = Contador_Campos(Formulrio - 10)
    Grava_Cabealho_Impresso_Tabela
    Abre_Tabela
    Select Case Tipo_Operao
     Case 8
      Tabela.MoveFirst
      Do Until Tabela.EOF
         Nmero_Varivel = Nmero_Varivel_Secundria + 1
         Grava_Registro_Impresso_Alternativa
         Tabela.MoveNext
      Loop
     Case 81
      Tabela.Seek "=", Cod_Projeto_Aux, 1
      If Tabela.NoMatch Then
         Print #1, Tab(15); "No foi encontrado este Projeto na Tabela " & Tabela.Name
      Else
         Do Until Cod_Projeto_Aux <> Tabela!Cod_Projeto
            Nmero_Varivel = Nmero_Varivel_Secundria + 1
            Grava_Registro_Impresso_Alternativa
            Tabela.MoveNext
         Loop
      End If
     Case 83
       Tabela.Seek "=", Cod_Projeto_Aux, Cod_Alternativa_Aux
       If Tabela.NoMatch Then
          Print #1, Tab(15); "No foi encontrado este Projeto na Tabela " & Tabela.Name
       Else
          Nmero_Varivel = Nmero_Varivel_Secundria + 1
          Grava_Registro_Impresso_Alternativa
       End If
    End Select
    Tabela.Close
    Nmero_Varivel_Secundria = Nmero_Varivel_Secundria + Nmero_Campos
    Formulrio = Formulrio + 1
 Loop
End Sub

Sub Imprime_Dados_Projeto()
 Nmero_Varivel_Secundria = 3
 Dim Contador_Campos
 If Tipo_Servio = 22 Then
    Contador_Campos = Array(10, 6, 9, 17, 7, 5, 21, 18, 19, 2, 23, 22, 4, 16, 20, 6, 5, 4, 5, 10, 4, 8, 6)
 Else
   Contador_Campos = Array(10, 6, 9, 17, 7, 5, 21, 18, 19, 23, 22, 4, 16, 20, 6, 5, 4, 5, 10, 4, 8, 6)
 End If
 Formulrio = 1
 Abre_Tabela
 Tabela.MoveFirst
 If Tipo_Operao = 8 Or Tipo_Servio = 22 Then
    Do Until Tabela.EOF
       Grava_Formulrio_Principal
    Loop
 Else
    Tabela.Seek "=", Cod_Projeto_Aux
    Grava_Formulrio_Principal
 End If
 Tabela.Close
 Formulrio = 2
 Do Until Formulrio > 9
    Nmero_Campos = Contador_Campos(Formulrio - 1)
    Grava_Cabealho_Impresso_Tabela
    Abre_Tabela
    If Tipo_Operao = 8 Then
       Tabela.MoveFirst
       Do Until Tabela.EOF
          Grava_Registro_Impresso_Projeto
       Loop
    Else
       Tabela.Seek "=", Cod_Projeto_Aux
       If Tabela.NoMatch Then
          Print #1, Tab(15); "No foi encontrado este Projeto na Tabela " & Tabela.Name
       Else
         Grava_Registro_Impresso_Projeto
       End If
    End If
    Tabela.Close
    Nmero_Varivel_Secundria = Nmero_Varivel_Secundria + Nmero_Campos
    Formulrio = Formulrio + 1
 Loop
End Sub



Sub Imprime_Resultado()
 Printer.PrintQuality = -1
 Do Until EOF(1)
    Line Input #1, Linha
    Printer.Print Linha
    Contador_Linhas = Contador_Linhas + 1
    If Contador_Linhas = 60 Then
       Contador_Pginas = Contador_Pginas + 1
       Printer.NewPage
       Printer.Print Tab(30); " Continuao  - Pgina " & Contador_Pginas
       Printer.Print
       Printer.Print
       Contador_Linhas = 3
    End If
 Loop
 Printer.EndDoc
End Sub



Sub Inclui_Tabela_Alternativa()
 Select Case Tipo_Operao
  Case 2
   Tabela.AddNew
   Mensagem_1 (14)
  Case 3
   Tabela.Seek "=", Cod_Projeto_Aux
   Tabela.Edit
 End Select
 For I% = 1 To 25
     Campo_Tabela = I%
     Verifica_Vetor_Alternativas
 Next
   Tabela(0) = Cod_Projeto_Aux
   Tabela(1) = Cod_Alternativa_Aux
   For I% = 2 To Contador_Controle
   Tabela(I%) = Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, I% - 1)
   Next
   Tabela.Update
 For I% = 1 To 12
     For J% = 1 To 25
         Limpa_Vetor_Alternativas
     Next
 Next
 Contador_Alternativas = Contador_Alternativas + 1
End Sub

Sub Inclui_Tabela_A_01()
 If (Tipo_Operao = 1 Or Tipo_Operao = 2) Then
    Tabela_A_01.AddNew
    Mensagem_1 (14)
 Else
    Tabela_A_01.Seek "=", Cod_Projeto_Aux
    Tabela_A_01.Edit
 End If
 Tabela_A_01("COD_PROJETO") = Cod_Projeto_Aux
 Tabela_A_01("DESC_PROJETO") = Vetor_Projeto(Cod_Projeto_Aux, 1, 2)
 Tabela_A_01("AM_PILOTO") = Vetor_Projeto(Cod_Projeto_Aux, 1, 5)
 Tabela_A_01("EST_PROJETO") = Vetor_Projeto(Cod_Projeto_Aux, 1, 1)
 Tabela_A_01("DATA_AVALIAO") = Vetor_Projeto(Cod_Projeto_Aux, 1, 3)
 Tabela_A_01("NUM_ALTERNATIVAS") = Num_Alternativas_Aux
 Tabela_A_01("ST_AVALIAO") = Vetor_Projeto(Cod_Projeto_Aux, 1, 4)
 Tabela_A_01("TEC_AVALIAO") = Vetor_Projeto(Cod_Projeto_Aux, 1, 10)
 Tabela_A_01("TIPO_PROJETO") = Vetor_Projeto(Cod_Projeto_Aux, 1, 8)
 Tabela_A_01("MAP_SITUAO") = Vetor_Projeto(Cod_Projeto_Aux, 1, 6)
 Tabela_A_01("MAP_LOCALIZAO") = Vetor_Projeto(Cod_Projeto_Aux, 1, 7)
 Tabela_A_01.Update
 Tabela_A_01.Close
End Sub



















































'
Sub Inclui_Tabela_F_01()
 Tabela_F_01.AddNew
 Tabela_F_01("NUM_ALEATRIO") = Num_Aleatrio_Aux
 Tabela_F_01("COD_PROJETO") = Tabela_A_01!Cod_Projeto
 Tabela_F_01("ST_AVAL") = Tabela_A_01!ST_AVALIAO
 Tabela_F_01.Update
 
End Sub




Sub Inclui_Tabela_G_01()
 Tabela_G_01.AddNew
 Tabela_G_01!Ordem = Prioridades_Resultado(I%, J%, 1) & Contador
 Tabela_G_01!Contagem = Contador
 Tabela_G_01!COD_ALTERNATIVA = I%
 Tabela_G_01.Update

End Sub

Sub Inclui_Tabela_Projeto()
Select Case Tipo_Operao
  Case 1
   Tabela.AddNew
  Case 2
   Tabela.AddNew
   Mensagem_1 (14)
  Case 3
   Tabela.Seek "=", Cod_Projeto_Aux
   Tabela.Edit
 End Select
 For I% = 1 To 23
     For J% = 1 To Contador_Controle
         Campo_Tabela = J%
         Verifica_Vetor_Projeto
     Next
 Next
 Tabela(0) = Cod_Projeto_Aux
 For J% = 1 To 23
     For K% = 1 To Contador_Controle
         If J% = Formulrio Then
            Tabela(K%) = Vetor_Projeto(Cod_Projeto_Aux, J%, K%)
         End If
     Next
 Next
 Tabela.Update
 Tabela.Close
 For J% = 1 To 23
     For K% = 1 To Contador_Controle
         Limpa_Vetor_Projeto
     Next
 Next
'' Tabela_A_01.Close
End Sub


Sub Inclui_Tabela_Projeto_Alternativas()
 Dim Contador_Campos
 If Tipo_Operao = 1 Then
 Contador_Campos = Array(9, 6, 9, 17, 7, 5, 21, 18, 19, 2, 23, 22, 4, 16, 20, 6, 5, 4, 5, 10, 4, 8, 6)
 Else
  Contador_Campos = Array(6, 6, 9, 17, 7, 5, 21, 18, 19, 2, 23, 22, 4, 16, 20, 6, 5, 4, 5, 10, 4, 8, 6)
 End If
 For I% = 1 To 9
     Formulrio = I%
     For J% = 1 To 25
         Campo_Tabela = J%
         Verifica_Vetor_Projeto
     Next
     Abre_Tabela
     Tabela.AddNew
     Tabela(0) = Cod_Projeto_Aux
     For J% = 1 To Contador_Campos(I% - 1)
     Tabela(J%) = Vetor_Projeto(Cod_Projeto_Aux, Formulrio, J%)
      Next
     Tabela.Update
     Tabela.Close
     For J% = 1 To 25
         Campo_Tabela = J%
         Vetor_Projeto(Cod_Projeto_Aux, I%, J%) = ""
     Next
 Next
 For I% = 10 To 23
     Formulrio = I%
     For J% = 1 To 12
         Cod_Alternativa_Aux = J%
         For K% = 1 To 25
             Campo_Tabela = K%
             Verifica_Vetor_Alternativas
         Next
     Next
     For J% = 1 To Num_Alternativas_Aux
         Cod_Alternativa_Aux = J%
         Abre_Tabela
         Tabela.AddNew
         Tabela(0) = Cod_Projeto_Aux
         Tabela(1) = Cod_Alternativa_Aux
         For K = 2 To Contador_Campos(I% - 1) + 1
             Tabela(K%) = Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, K% - 1)
         Next
         Tabela.Update
         Tabela.Close
     Next
     For J% = 1 To 12
         For K% = 1 To 25
             Vetor_Alternativas(J%, I%, K%) = ""
         Next
     Next
 Next
 Mensagem_1 (14)
 Mensagem_1 (12)
 If Resposta = 6 Then
    If Tipo_Operao = 1 Then
       F100001.Show 1
    Else
       F000002.Show 1
    End If
 Else
    Unload Form
 End If
End Sub
Sub Inicializa_Vetor_Alternativas()
For I = 1 To 12
    Cod_Alternativa_Aux = I%
    For J = 1 To 23
        Formulrio = I%
        For K = 1 To 25
            Campo_Tabela = K%
            Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, Campo_Tabela) = ""
        Next
     Next
 Next
End Sub


Sub Limpa_Campos()
 Select Case Formulrio
  Case 2
   For I = 0 To Contador_Controle
       If I% = 0 Then
          Form.Controls(I%) = ""
       Else
          If I% < 5 Then
             Form.Controls(I%) = 0
          Else
             Form.Controls(I%) = ""
          End If
       End If
   Next
  Case 3, 4, 5, 6
   For I = 0 To Contador_Controle
       If I% = 0 Then
          Form.Controls(I%) = ""
       Else
          Form.Controls(I%) = 0
       End If
   Next
  Case 7, 8, 10, 12 To 19, 22, 23
   For I = 1 To Contador_Controle
       Form.Controls(I%) = ""
   Next
  Case 9
   For I = 0 To Contador_Controle
       If I% < 5 Then
          Form.Controls(I%) = ""
       Else
          Form.Controls(I%) = 0
       End If
   Next
  Case 11
   For I = 1 To 19
       Form.Controls(I%) = ""
   Next
   For I = 20 To 24
       Form.Controls(I%) = 0
   Next
  Case 20, 21
   For I = 1 To Contador_Controle
       If I% = 1 Then
          Form.Controls(I%) = ""
       Else
          Form.Controls(I%) = 0
       End If
   Next
 End Select
End Sub

Sub Limpa_Campos_Auxiliares_F100001()
 Desc_Projeto_Aux = ""
 Est_Projeto_Aux = ""
 Am_Piloto_Aux = False
 Data_Avaliao_Aux = 0
 Num_Alternativas_Aux = 0
 St_Avaliao_Aux = 0
 Tec_Avaliao_Aux = 0
 Tipo_Projeto_Aux = 0
 Map_Situao_Aux = ""
 Map_Localizao_Aux = ""
End Sub


'
'--------------------------------------------------
' Procedimentos de Limpeza de Campos dos
' Formulrios
'--------------------------------------------------





Sub Inicializa_Seleo_Consulta()
 Dim I%
 For I% = 1 To 7
     Seleo_Consulta(I%) = 0
 Next
End Sub






























Sub Limpa_Vetor_Alternativas()
  Select Case Formulrio
   Case 20, 21
     Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, I%) = 0
   Case 10, 12, 17, 18, 19, 22, 23
     Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, I%) = ""
   Case 11
     If I% < 20 Then
     Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, I%) = ""
     Else
      Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, I%) = 0
     End If
  End Select
End Sub


Sub Limpa_Vetor_Projeto()
 Select Case Formulrio
   Case 2
   If K% < 5 Then
       Vetor_Projeto(Cod_Projeto_Aux, J%, K%) = 0
    Else
     Vetor_Projeto(Cod_Projeto_Aux, J%, K%) = ""
    End If
   Case 3, 4, 5, 6
     Vetor_Projeto(Cod_Projeto_Aux, J%, K%) = 0
   Case 7
    Vetor_Projeto(Cod_Projeto_Aux, J%, K%) = ""
  End Select
End Sub




Sub Preenche_Alternativas()
 Abre_Consulta_Alternativa
 Do Until Consulta_Alternativa.EOF
    If Cod_Projeto_Aux = Consulta_Alternativa!Cod_Projeto Then
       Cod_Alternativa_Aux = Consulta_Alternativa!COD_ALTERNATIVA
       Exit Do
    Else
    Consulta_Alternativa.MoveNext
    End If
 Loop
 If Consulta_Alternativa.NoMatch Then
    Consulta_Alternativa.Close
    Mensagem_1 (26)
 Else
    Nmero_Ocorrncias = 1000
    Chama_Progresso
    F100010.Show 1
 End If
End Sub

Sub Preenche_Combo_Change()
 Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, Contador_Controle) = Combo1
 Form.Controls(Contador_Controle + 1).Enabled = True
'' Form.Controls(Contador_Controle + 1).SetFocus
 Form.Controls(Contador_Controle).Enabled = False
End Sub

Sub Preenche_Controle_Checagem()
 Select Case Tipo_Operao
  Case 1, 2, 9
   Form.Controls(Contador_Controle + 1).Enabled = True
   Form.Controls(Contador_Controle + 1).SetFocus
   Form.Controls(Contador_Controle).Enabled = False
  End Select
End Sub


Sub Preenche_Controle_Checagem_Percentual()
 On Error GoTo Manipulador_Erros
 If Form.Controls(Contador_Controle) <> "" Then
    Select Case Tipo_Operao
     Case 1, 2, 9
      Contador_Controle_Aux = Contador_Controle
      If Form.Controls(Contador_Controle) <= 100 Then
         Vetor_Projeto(Cod_Projeto_Aux, Formulrio, Contador_Controle) = Form.Controls(Contador_Controle)
         Soma = 0
         For I% = (Contador_Controle - (Contador_Percentual - 1)) To Contador_Controle_Aux
             Soma = Soma + Vetor_Projeto(Cod_Projeto_Aux, Formulrio, I%)
         Next
         If Soma <> 100 Then
            If Soma <> 0 Then
               Contador_Controle = Contador_Controle - (Contador_Percentual - 1)
               For I% = Contador_Controle To Contador_Controle_Aux
                   Form.Controls(I%) = ""
               Next
               Mensagem_1 (17)
               Soma = 0
               Form.Controls(Contador_Controle).Enabled = True
               Form.Controls(Contador_Controle).SetFocus
            Else
               Contador_Controle = Contador_Controle + 1
               Form.Controls(Contador_Controle).Enabled = True
               Form.Controls(Contador_Controle).SetFocus
               Form.Controls(Contador_Controle - 1).Enabled = False
            End If
         Else
               Soma = 0
               Contador_Controle = Contador_Controle + 1
               Form.Controls(Contador_Controle).Enabled = True
               Form.Controls(Contador_Controle).SetFocus
               Form.Controls(Contador_Controle - 1).Enabled = False
            End If
         Else
            Mensagem_1 (5)
            Form.Controls(Contador_Controle) = ""
            Form.Controls(Contador_Controle).SetFocus
         End If
         End Select
         End If
        
Manipulador_Erros:
 Select Case Err.Number
  Case 13
   Form.Controls(Contador_Controle) = 0
   If Contador_Controle = Contador_Percentual Then
      If Soma = 0 Or Soma = 100 Then
         Form.Controls(Contador_Controle + 1).SetFocus
      Else
         Contador_Controle = Contador_Controle - (Contador_Percentual - 1)
         For I% = Contador_Controle To Contador_Controle_Aux
             Form.Controls(I%) = ""
         Next
         Mensagem_1 (17)
         Soma = 0
         Form.Controls(Contador_Controle).Enabled = True
         Form.Controls(Contador_Controle).SetFocus
      End If
   Else
      Contador_Controle = Contador_Controle + 1
      Form.Controls(Contador_Controle).Enabled = True
      Form.Controls(Contador_Controle).SetFocus
      Form.Controls(Contador_Controle - 1).Enabled = False
  End If
 End Select
End Sub

Sub Preenche_Controle_Checagem_ltimo()
 Select Case Tipo_Operao
     Case 1, 9
      If Formulrio < 10 Then
         Vetor_Projeto(Cod_Projeto_Aux, Formulrio, Contador_Controle) = Form.Controls(Contador_Controle)
         Form.Controls(Contador_Controle).Enabled = False
         Form.Cmd01.Enabled = True
      Else
         Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, Contador_Controle) = Form.Controls(Contador_Controle)
         Form.Controls(Contador_Controle).Enabled = False
         Form.Cmd01.Enabled = True
         Form.Cmd01.Default = True
       End If
     Case 2
       Form.Cmd01.Enabled = True
       Form.Cmd01.SetFocus
       Form.Controls(Contador_Controle).Enabled = False
    
      End Select
End Sub

Sub Preenche_Controle_Combo()
 Select Case Tipo_Operao
  Case 1, 2, 9
   If Form.Controls(Contador_Controle) <> "" Then
      Abre_Tabela_1
      Tabela_1.Seek "=", Form.Controls(Contador_Controle)
      If Tabela_1.NoMatch Then
         Mensagem_1 (4)
         End
       Else
        If Formulrio < 10 Then
           Vetor_Projeto(Cod_Projeto_Aux, Formulrio, Contador_Controle) = Tabela_1.Fields(0)
        Else
           If Tipo_Operao = 1 Or Tipo_Operao = 9 Then
              Cod_Alternativa_Aux = Contador_Alternativas
           End If
         Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, Contador_Controle - 1) = Tabela_1.Fields(0)
         End If
         Form.Controls(Contador_Controle + 1).Enabled = True
         Form.Controls(Contador_Controle + 1).SetFocus
         Form.Controls(Contador_Controle).Enabled = False
         Contador_Controle = Contador_Controle + 1
       End If
       Tabela_1.Close
    End If
   End Select
 End Sub




Sub Preenche_Controle_Combo_ltimo()
 If Form.Controls(Contador_Controle) <> "" Then
       Abre_Tabela_1
       Tabela_1.Seek "=", Form.Controls(Contador_Controle)
       Select Case Tipo_Operao
       Case 1, 9
        If Tabela_1.NoMatch Then
         Mensagem_1 (4)
         End
        Else
           If Formulrio < 10 Then
           Vetor_Projeto(Cod_Projeto_Aux, Formulrio, Contador_Controle) = Tabela_1.Fields(0)
          Else
           Cod_Alternativa_Aux = Contador_Alternativas
           Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, Contador_Controle - 1) = Tabela_1.Fields(0)
           Form.Controls(Contador_Controle).Enabled = False
           Form.Cmd01.Enabled = True
           Form.Cmd01.Default = True
           End If
          End If
        Case 2
           Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, Contador_Controle - 1) = Tabela_1.Fields(0)
           Form.Cmd01.Enabled = True
           Form.Cmd01.SetFocus
           Form.Controls(Contador_Controle).Enabled = False
   End Select
    Tabela_1.Close
 End If
End Sub

Sub Preenche_Controle_Texto()
 On Error GoTo Manipulador_Erros
 Valor_Entrada = Form.Controls(Contador_Controle)
 If Valor_Entrada >= Limite_Min And Valor_Entrada <= Limite_Max Then
    Select Case Tipo_Operao
     Case 1, 2, 9
      If Formulrio < 10 Then
         Vetor_Projeto(Cod_Projeto_Aux, Formulrio, Contador_Controle) = Form.Controls(Contador_Controle)
      Else
         If Tipo_Operao = 1 Or Tipo_Operao = 9 Then
            Cod_Alternativa_Aux = Contador_Alternativas
         End If
         Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, Contador_Controle - 1) = Form.Controls(Contador_Controle)
      End If
      Form.Controls(Contador_Controle + 1).Enabled = True
      Form.Controls(Contador_Controle + 1).SetFocus
      Form.Controls(Contador_Controle).Enabled = False
      Contador_Controle = Contador_Controle + 1
    End Select
 Else
    Mensagem_1 (27)
    Form.Controls(Contador_Controle) = ""
    Form.Controls(Contador_Controle).Enabled = True
    Form.Controls(Contador_Controle).SetFocus
 End If
Manipulador_Erros:
 Select Case Err.Number
  Case 13
    Form.Controls(Contador_Controle) = ""
    Contador_Controle = Contador_Controle + 1
    Form.Controls(Contador_Controle - 1).Enabled = False
    Form.Controls(Contador_Controle).Enabled = True
    Form.Controls(Contador_Controle).SetFocus
  End Select
End Sub
Sub Preenche_Controle_Texto_Percentual()
On Error GoTo Manipulador_Erros
 Valor_Entrada = Form.Controls(Contador_Controle)
 If Valor_Entrada >= Limite_Min And Valor_Entrada <= Limite_Max Then
    Vetor_Projeto(Cod_Projeto_Aux, Formulrio, Contador_Controle) = Form.Controls(Contador_Controle)
    Soma = Soma + Form.Controls(Contador_Controle)
    Contador_Controle = Contador_Controle + 1
    Form.Controls(Contador_Controle).Enabled = True
    Form.Controls(Contador_Controle).SetFocus
    Form.Controls(Contador_Controle - 1).Enabled = False
 Else
    Mensagem_1 (27)
    Form.Controls(Contador_Controle) = ""
    Form.Controls(Contador_Controle).SetFocus
 End If
 Valor_Entrada = ""
Manipulador_Erros:
 Select Case Err.Number
  Case 13
    Form.Controls(Contador_Controle) = 0
    Vetor_Projeto(Cod_Projeto_Aux, Formulrio, Contador_Controle) = Form.Controls(Contador_Controle)
    Contador_Controle = Contador_Controle + 1
    Form.Controls(Contador_Controle).Enabled = True
    Form.Controls(Contador_Controle).SetFocus
    Form.Controls(Contador_Controle - 1).Enabled = False
  End Select
End Sub

Sub Preenche_Controle_Texto_ltimo()
 On Error GoTo Manipulador_Erros
 Valor_Entrada = Form.Controls(Contador_Controle)
 If Valor_Entrada >= Limite_Min And Valor_Entrada <= Limite_Max Then
    If Formulrio < 10 Then
       Vetor_Projeto(Cod_Projeto_Aux, Formulrio, Contador_Controle) = Form.Controls(Contador_Controle)
    Else
       Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, Contador_Controle - 1) = Form.Controls(Contador_Controle)
    End If
    Form.Cmd01.Enabled = True
    Form.Cmd01.SetFocus
 Else
    Mensagem_1 (27)
    Form.Controls(Contador_Controle) = ""
    Form.Controls(Contador_Controle).SetFocus
 End If
 Valor_Entrada = ""
Manipulador_Erros:
 Select Case Err.Number
  Case 13
    Form.Cmd01.Enabled = True
    Form.Cmd01.SetFocus
  End Select

End Sub



Sub Preenche_Dados_Formulrio()
 Select Case Tipo_Operao
  Case 1, 9
   Form.Controls(0) = Cod_Projeto_Aux
   Form.Controls(0).Enabled = False
   Form.Cmd01.Default = True
   Select Case Formulrio
    Case 1 To 9
     Form.Controls(1).Enabled = True
    Case 10 To 23
     Form.Controls(1) = Contador_Alternativas
     Form.Controls(1).Enabled = False
     Form.Controls(2).Enabled = True
   End Select
  Case 2
     Form.Controls(0).Enabled = True
     Form.Cmd01.Caption = "OK"
  Case 3
   Form.Controls(0).Enabled = False
   Form.Controls(0) = Cod_Projeto_Aux
  Case 7, 10
   Form.Cmd01.Enabled = True
   Form.Cmd01.Default = True
   Form.Controls(0) = Cod_Projeto_Aux
   Form.Controls(0).Enabled = False
   Form.Controls(1).Enabled = False
   End Select
End Sub

Sub Preenche_Formulrio_Inicial()
 Abre_Tabela
 If Formulrio < 10 Then
    Tabela.Seek "=", Cod_Projeto_Aux
 Else
    Tabela.Seek "=", Cod_Projeto_Aux, Cod_Alternativa_Aux
 End If
 Form.Controls(0) = Cod_Projeto_Aux
 Form.Controls(0).Enabled = False
 If Tabela.NoMatch Then
    Tabela.Close
    Form.Aviso.Visible = True
    If Formulrio > 9 Then
       Form.Controls(1) = Cod_Alternativa_Aux
    End If
 Else
    If Formulrio < 10 Then
       Preenche_Formulrio_Projeto
    Else
       Preenche_Formulrio_Alternativas
    End If
''    Tabela.Close
 End If

End Sub

Sub Preenches_Campos_Formulrio_Projeto()
 For I = 1 To Contador_Controle
   Select Case Formulrio
    Case 1
    '' Campos_Formulrio(1, I%) = Tabela.Fields(I%)
     Form.Controls(I%) = Tabela.Fields(I%)
   End Select
 Next
  Tabela_A_01_01_Aux.Seek "=", Tabela_A_01!EST_PROJETO
  F100001.Est_Projeto_1 = Tabela_A_01_01_Aux!NOME_ESTADO
  Est_Projeto_1_Aux = Tabela_A_01_01_Aux!NOME_ESTADO
 Tabela_A_01_01_Aux.Close
 F100001.Data_Avaliao_1 = Tabela_A_01!DATA_AVALIAO
 F100001.Num_Alternativas_1 = Tabela_A_01!Num_Alternativas
 ''Abre_Tabela_A_01_04_Aux
  Tabela_A_01_04_Aux.Seek "=", Tabela_A_01!ST_AVALIAO
  St_Avaliao_1_Aux = Tabela_A_01_04_Aux!NOME_ST_AVALIAO
  F100001.St_Avaliao_1 = Tabela_A_01_04_Aux!NOME_ST_AVALIAO
 Tabela_A_01_04_Aux.Close
'' Abre_Tabela_A_01_02_Aux
  Tabela_A_01_02_Aux.Seek "=", Tabela_A_01!TEC_AVALIAO
  Tec_Avaliao_1_Aux = Tabela_A_01_02_Aux!NOME_TCNICA
  F100001.Tec_Avaliao_1 = Tabela_A_01_02_Aux!NOME_TCNICA
 Tabela_A_01_02_Aux.Close
'' Abre_Tabela_A_01_03_Aux
  Tabela_A_01_03_Aux.Seek "=", Tabela_A_01!Tipo_Projeto
  Tipo_Projeto_1_Aux = Tabela_A_01_03_Aux!NOME_TIPO
  F100001.Tipo_Projeto_1 = Tabela_A_01_03_Aux!NOME_TIPO
 Tabela_A_01_03_Aux.Close
 Open "C:\EVALUATOR\MAPAS\" & Tabela_A_01!MAP_SITUAO For Binary As #1
  F100001.Map_Situao_1.ReadFromFile 1
  Close #1
 Open "C:\EVALUATOR\MAPAS\" & Tabela_A_01!MAP_LOCALIZAO For Binary As #2
  F100001.Map_Localizao_1.ReadFromFile 2
  Close #2
End Sub

Sub Grava_Formulrio_Principal()
 Print #1, String(80, "-")
 Print #1, Tab(7); "DADOS DA TABELA A-01-QUALIFICAO DO PROJETO"
 Print #1, String(80, "-")
 If Tipo_Servio <> 22 Then
 Print #1, Tab(10); "Dados do Projeto: "; Tabela_A_01!Cod_Projeto
 End If
 Print #1, Tab(15); "Varivel ===> Descrio do Projeto"
 Print #1, Tab(15); "Valor ===> "; Tabela_A_01!DESC_PROJETO
 If Tipo_Servio <> 22 Then
    Print #1, Tab(15); "Varivel ===> Estado do Projeto"
    Print #1, Tab(15); "Valor ===> "; Tabela_A_01!EST_PROJETO
    Print #1, Tab(15); "Varivel ===> Amostra Piloto"
    Print #1, Tab(15); "Valor ===> "; Tabela_A_01!Am_PILOTO
 End If
 Print #1, Tab(15); "Varivel ===> Data da Avaliao"
 Print #1, Tab(15); "Valor ===> "; Tabela_A_01!DATA_AVALIAO
 Print #1, Tab(15); "Varivel ===> Nmero de Alternativas"
 Print #1, Tab(15); "Valor ===> "; Tabela_A_01!Num_Alternativas
 If Tipo_Servio <> 22 Then
    Print #1, Tab(15); "Varivel ===> Status da Avaliao"
    Print #1, Tab(15); "Valor ===> "; Tabela_A_01!ST_AVALIAO
    Print #1, Tab(15); "Varivel ===> Tcnica de Avaliao"
    Print #1, Tab(15); "Valor ===> "; Tabela_A_01!TEC_AVALIAO
 End If
 Print #1, Tab(15); "Varivel ===> Tipo de Projeto"
 Print #1, Tab(15); "Valor ===> "; Tabela_A_01!Tipo_Projeto
 Tabela.MoveNext
End Sub

Sub Preenche_Formulrio()
 On Error Resume Next
 Abre_Tabela
 Debug.Print "aBRI A TABELA:"; Tabela.Name
 If Formulrio < 10 Then
    Tabela.Seek "=", Cod_Projeto_Aux
 Else
    Tabela.Seek "=", Cod_Projeto_Aux, Cod_Alternativa_Aux
 End If
 Form.Controls(0) = Cod_Projeto_Aux
 Form.Controls(0).Enabled = False
 If Tabela.NoMatch Then
    Tabela.Close
    Form.Aviso.Visible = True
    If Formulrio > 9 Then
       Form.Controls(1) = Cod_Alternativa_Aux
    End If
 Else
    If Formulrio < 10 Then
       Preenche_Formulrio_Projeto
    Else
       Preenche_Formulrio_Alternativas
    End If
    Tabela.Close
 End If
End Sub


Sub Preenche_Formulrio_Alternativas()
 St_Achou_Registro = True
 Dim Contador_Campos
 Dim Nmero_Campos As Integer
 Contador_Campos = Array(2, 23, 22, 4, 16, 20, 6, 5, 4, 5, 10, 4, 8, 6)
 Nmero_Campos = Contador_Campos(Formulrio - 10) + 1
 Consulta_Tabela_Auxiliar
 For J% = 1 To Nmero_Campos
     Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, J%) = Tabela.Fields(J%)
     Select Case VarType(Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, J%))
      Case 2, 6
       If Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, J%) = -32768 Then
          Form.Controls(J%) = " ? "
       Else
          Form.Controls(J%) = Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, J%)
       End If
      Case 8
          Form.Controls(J%) = Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, J%)
      Case 11
       If Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, J%) = True Then
          Form.Controls(J%) = 1
       Else
          Form.Controls(J%) = 0
       End If
     End Select
 Next
End Sub






Sub Preenche_Formulrio_Projeto()
  Dim Contador_Campos
  Dim Nmero_Campos As Integer
  St_Achou_Registro = True
  Contador_Campos = Array(6, 9, 17, 7, 5, 21, 18, 19)
  Nmero_Campos = Contador_Campos(Formulrio - 2)
  Consulta_Tabela_Auxiliar
  For J% = 1 To Nmero_Campos
    Vetor_Projeto(Cod_Projeto_Aux, Formulrio, J%) = Tabela.Fields(J%)
      Debug.Print "varivel:"; VarType(Vetor_Projeto(Cod_Projeto_Aux, Formulrio, J%))
      Debug.Print "Valor:"; Vetor_Projeto(Cod_Projeto_Aux, Formulrio, J%)
      Select Case VarType(Vetor_Projeto(Cod_Projeto_Aux, Formulrio, J%))
      Case 2, 6
       If Vetor_Projeto(Cod_Projeto_Aux, Formulrio, J%) = -32768 Then
          Form.Controls(J%) = "?"
       Else
          Form.Controls(J%) = Vetor_Projeto(Cod_Projeto_Aux, Formulrio, J%)
       End If
      Case 8
          Form.Controls(J%) = Vetor_Projeto(Cod_Projeto_Aux, Formulrio, J%)
      Case 9
      Case 11
       If Vetor_Projeto(Cod_Projeto_Aux, Formulrio, J%) = True Then
          Form.Controls(J%) = 1
       Else
          Form.Controls(J%) = 0
       End If
     End Select
 Next
End Sub


Sub Preenche_Lista_Alterao_Projeto()
 If St_Achou_Registro = True Then
    St_Achou_Registro = False
    Abre_Tabela_D_01
    Tabela_D_01.Seek "=", Nmero_Varivel
    Do Until Tabela_D_01!COD_VAR > Nmero_ltima_Varivel
       If Tabela_D_01!COD_VAR < 10 Then
          F102001.Lista01_01.AddItem "V00" & Tabela_D_01!COD_VAR & "-" & Tabela_D_01!NOME_VAR
       Else
          If Tabela_D_01!COD_VAR < 100 Then
             Select Case Tabela_D_01!COD_VAR
              Case 48
               F102001.Lista01_01.AddItem "V048  V052-Composio tnica"
              Case 53
               F102001.Lista01_01.AddItem "V053  V056-Composio Etria"
              Case 57 To 59
               F102001.Lista01_01.AddItem "V0" & Tabela_D_01!COD_VAR & "-" & Tabela_D_01!NOME_VAR
              Case 60
               F102001.Lista01_01.AddItem "V060  V063-Atividades Econmicas"
              Case 64
               F102001.Lista01_01.AddItem "V064  V067-Nveis de Segregao"
              Case 68
               F102001.Lista01_01.AddItem "V0" & Tabela_D_01!COD_VAR & "-" & Tabela_D_01!NOME_VAR
              Case 87
               F102001.Lista01_01.AddItem "V087  V090-Nvel de Financiamento"
              Case 4 To 47, 69 To 86, 87 To 99
               F102001.Lista01_01.AddItem "V0" & Tabela_D_01!COD_VAR & "-" & Tabela_D_01!NOME_VAR
             End Select
          Else
             F102001.Lista01_01.AddItem "V" & Tabela_D_01!COD_VAR & "-" & Tabela_D_01!NOME_VAR
          End If
       End If
       Tabela_D_01.MoveNext
    Loop
 End If
End Sub


Sub Procura_Limites_Normalizao()
 Abre_Tabela_D_01
 Select Case Formulrio
  Case 2
   Tabela_D_01.Seek "=", Contador_Controle + 3
  Case 3
   Tabela_D_01.Seek "=", Contador_Controle + 9
  Case 4
   Tabela_D_01.Seek "=", Contador_Controle + 18
  Case 5
   Tabela_D_01.Seek "=", Contador_Controle + 35
  Case 6
   Tabela_D_01.Seek "=", Contador_Controle + 42
  Case 7
   Tabela_D_01.Seek "=", Contador_Controle + 47
  Case 8
   Tabela_D_01.Seek "=", Contador_Controle + 68
  Case 9
   Tabela_D_01.Seek "=", Contador_Controle + 86
  Case 10
   Tabela_D_01.Seek "=", Contador_Controle + 104
  Case 11
   Tabela_D_01.Seek "=", Contador_Controle + 106
  Case 12
   Tabela_D_01.Seek "=", Contador_Controle + 129
  Case 13
   Tabela_D_01.Seek "=", Contador_Controle + 151
  Case 14
   Tabela_D_01.Seek "=", Contador_Controle + 155
  Case 15
   Tabela_D_01.Seek "=", Contador_Controle + 171
  Case 16
   Tabela_D_01.Seek "=", Contador_Controle + 191
  Case 17
   Tabela_D_01.Seek "=", Contador_Controle + 197
  Case 18
   Tabela_D_01.Seek "=", Contador_Controle + 202
  Case 19
   Tabela_D_01.Seek "=", Contador_Controle + 206
  Case 20
   Tabela_D_01.Seek "=", Contador_Controle + 211
  Case 21
   Tabela_D_01.Seek "=", Contador_Controle + 221
  Case 22
   Tabela_D_01.Seek "=", Contador_Controle + 225
  Case 23
   Tabela_D_01.Seek "=", Contador_Controle + 233
  End Select
 Limite_Min = Tabela_D_01!LIM_MNIMO
 Select Case Formulrio
  Case 1 To 6, 8, 10 To 23
   Limite_Max = Tabela_D_01!LIM_MXIMO
  Case 7
   Select Case Contador_Controle
    Case 1 To 4
     Limite_Max = 100 - Soma
    Case 5
     Limite_Max = 100 - Soma
     Limite_Min = 100 - Soma
    Case 6 To 9
     Limite_Max = 100 - Soma
    Case 10 To 12
     Limite_Max = Tabela_D_01!LIM_MXIMO
    Case 13 To 16
     Limite_Max = 100 - Soma
    Case 17 To 20
     Limite_Max = 100 - Soma
    Case 21
     Limite_Max = Tabela_D_01!LIM_MXIMO
    End Select
   Case 9
    Select Case Contador_Controle
     Case 1 To 4
      Limite_Max = 100 - Soma
     Case 5 To 19
      Limite_Max = Tabela_D_01!LIM_MXIMO
     End Select
  End Select
 Form.Aviso001.Visible = True
 Form.Aviso002.Visible = True
 Form.Aviso003.Visible = True
 Form.Aviso004.Visible = True
 Form.Aviso005.Visible = True
 Form.Aviso006.Visible = True
 Form.Aviso007.Visible = True
 Form.Aviso005 = Limite_Max
 Form.Aviso006 = Limite_Min
 Form.Aviso007 = Tabela_D_01!UN_MEDIDA
 Tabela_D_01.Close
End Sub

Sub Abre_Tabela_Y_01()
 Set Tabela_Y_01 = BD.OpenRecordset("Tabela-Y-01", dbOpenTable)
 Tabela_Y_01.Index = "PrimaryKey"
End Sub

Sub Verifica_Preenchimento_Alternativa()
 If Form.Cod_Alternativa_1 > 0 Then
    Select Case Tipo_Operao
     Case 1, 9
      Form.Cod_Alternativa_1 = Contador_Alternativas
      Cod_Alternativa_Aux = Contador_Alternativas
      Form.Controls(2).Enabled = True
      Form.Controls(2).SetFocus
      Form.Cod_Alternativa_1.Enabled = False
     Case 2
      Cod_Alternativa_Aux = Form.Cod_Alternativa_1
      If Form.Cod_Alternativa_1 <= Num_Alternativas_Aux Then
         Tabela.Seek "=", Cod_Projeto_Aux, Cod_Alternativa_Aux
         If Tabela.NoMatch Then
            Form.Controls(2).Enabled = True
            Form.Controls(2).SetFocus
            Form.Cod_Alternativa_1.Enabled = False
          Else
            Mensagem_1 (21)
            Form.Cod_Alternativa_1 = ""
            Form.Cod_Alternativa_1.SetFocus
            St_Achou_Registro = True
          End If
        If St_Achou_Registro = False Then
                Form.Controls(2).Enabled = True
                Form.Controls(2).SetFocus
                Form.Cod_Alternativa_1.Enabled = False
             End If
          Else
             Mensagem_1 (22)
             Form.Cod_Alternativa_1 = ""
             Form.Cod_Alternativa_1.SetFocus
          End If
       End Select
    Else
       Mensagem_1 (5)
       Form.Cod_Alternativa_1 = ""
       Form.Cod_Alternativa_1.SetFocus
    End If
End Sub
Sub Verifica_Preenchimento_Projeto()
 On Error GoTo Manipulador_Erros
 If Form.Controls(0) <> "" Then
    Cod_Projeto_Aux = Form.Controls(0)
    Abre_Tabela_A_01
    Tabela_A_01.Seek "=", Cod_Projeto_Aux
    If Tabela_A_01.NoMatch Then
       Mensagem_1 (6)
       Form.Controls(0) = ""
       Form.Controls(0).SetFocus
    Else
       Num_Alternativas_Aux = Tabela_A_01!Num_Alternativas
       Select Case Formulrio
        Case 1 To 9
         Verifica_Preenchimento_Projeto_1
        Case 10 To 23
         Verifica_Preenchimento_Projeto_2
       End Select
    End If
 Else
    Mensagem_1 (1)
    Form.Controls(0) = ""
    Form.Controls(0).SetFocus
 End If
Manipulador_Erros:
 Select Case Err.Number
  Case 13
   Cod_Projeto_1 = ""
   Cod_Projeto_1.SetFocus
   Mensagem_1 (5)
  End Select
End Sub


Sub Verifica_Preenchimento_Projeto_1()
 Select Case Tipo_Operao
  Case 1
   Form.Controls(1).Enabled = True
   Form.Controls(1).SetFocus
   Form.Controls(0).Enabled = False
  Case 2
   Abre_Tabela
   Tabela.Seek "=", Cod_Projeto_Aux
   If Tabela.NoMatch Then
      Form.Controls(1).Enabled = True
      Form.Controls(1).SetFocus
      Form.Controls(0).Enabled = False
   Else
      Mensagem_1 (2)
      Form.Controls(0) = ""
      Form.Controls(0).Enabled = True
      Form.Controls(0).SetFocus
   End If
  End Select
End Sub

Sub Verifica_Preenchimento_Projeto_2()
 Select Case Tipo_Operao
  Case 1
   Form.Controls(1).Enabled = True
   Form.Controls(1).SetFocus
   Form.Controls(0).Enabled = False
  Case 2
   Cod_Alternativa_Aux = 1
   Abre_Tabela
   Tabela.Seek "=", Cod_Projeto_Aux, Cod_Alternativa_Aux
   If Tabela.NoMatch Then
      Form.Controls(1).Enabled = True
      Form.Controls(1).SetFocus
      Form.Controls(0).Enabled = False
   Else
      Conta_Alternativas
      If Contador_Alternativas < Num_Alternativas_Aux Then
         Form.Controls(1).Enabled = True
         Form.Controls(1).SetFocus
         Form.Controls(0).Enabled = False
      Else
         Mensagem_1 (20)
         Form.Controls(0) = ""
         Form.Controls(0).SetFocus
      End If
   End If
 End Select
End Sub









Sub Verifica_Tabela_Principal()
 
  Abre_Tabela_A_01
  Tabela_A_01.Seek "=", Cod_Projeto_Aux
End Sub


Sub Verifica_Vetor_Alternativas()
  Select Case Formulrio
   Case 20, 21
    If Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, Campo_Tabela) = "" Then
       Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, Campo_Tabela) = 0
    End If
   Case 10, 12 To 17, 18, 19, 22, 23
    If Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, Campo_Tabela) = "" Then
       Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, Campo_Tabela) = -32768
    End If
   Case 11
    If J < 19 Then
       If Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, Campo_Tabela) = "" Then
          Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, Campo_Tabela) = -32768
       End If
    Else
       If Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, Campo_Tabela) = False Then
          Vetor_Alternativas(Cod_Alternativa_Aux, Formulrio, Campo_Tabela) = 0
       End If
    End If
   End Select
End Sub


Sub Verifica_Vetor_Projeto()
 Select Case Formulrio
   Case 1
   If Vetor_Projeto(Cod_Projeto_Aux, Formulrio, Campo_Tabela) = "" Then
          Vetor_Projeto(Cod_Projeto_Aux, Formulrio, Campo_Tabela) = -32768
       End If
   Case 2
    If Campo_Tabela < 5 Then
       If Vetor_Projeto(Cod_Projeto_Aux, Formulrio, Campo_Tabela) = "" Then
          Vetor_Projeto(Cod_Projeto_Aux, Formulrio, Campo_Tabela) = 0
       End If
    Else
       If Vetor_Projeto(Cod_Projeto_Aux, Formulrio, Campo_Tabela) = "" Then
          Vetor_Projeto(Cod_Projeto_Aux, Formulrio, Campo_Tabela) = -32768
       End If
    End If
   Case 3, 4, 5, 6
    If Vetor_Projeto(Cod_Projeto_Aux, Formulrio, Campo_Tabela) = "" Then
       Vetor_Projeto(Cod_Projeto_Aux, Formulrio, Campo_Tabela) = 0
    End If
   Case 7
    If Vetor_Projeto(Cod_Projeto_Aux, Formulrio, Campo_Tabela) = "" Then
       Vetor_Projeto(Cod_Projeto_Aux, Formulrio, Campo_Tabela) = -32768
    End If
   End Select
End Sub

